package esi.examwh.bl;

import esi.examwh.dao.SubjectEditorDAO;
import esi.examwh.dao.common.RequestParameterException;
import esi.examwh.model.Person;
import esi.examwh.model.Subject;
import esi.examwh.model.SubjectEditor;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;

import com.plw.util.DataNotFoundException;

public class SubjectEditorBL {
	public static SubjectEditor Add(Session MyHSs,SubjectEditor ao_SubjectEditor, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		try{
			Person lo_Person  = ao_SubjectEditor.getOPersonID();
			Subject lo_Subject = ao_SubjectEditor.getOSubjectID();
			if(lo_Person != null && lo_Subject != null){
				try{
					Integer li_SubjectID = lo_Subject.getSubjectID();
					Integer li_PersonID = lo_Person.getPersonID();
					SubjectEditor lo_SubjectEditor = SubjectEditorDAO.GetByID(MyHSs, li_SubjectID, li_PersonID, SUID, SGID);
					if(lo_SubjectEditor != null){
						if(lo_SubjectEditor.getDataStatus() == TYPE_DATA_STATUS.STATUS_DISABLE){
							lo_SubjectEditor.setDataStatus(ao_SubjectEditor.getDataStatus());
							lo_SubjectEditor.setOrder(ao_SubjectEditor.getOrder());
							SubjectEditorDAO.Modify(MyHSs,lo_SubjectEditor, as_UserName, SUID, SGID);
							ao_SubjectEditor = lo_SubjectEditor;
						}else{
							throw new RequestParameterException("SubjectID [SubjectID:" + li_SubjectID +",PersonID:"+li_PersonID+ "] is not found.");
						}
					}else{
						SubjectEditorDAO.Add(MyHSs, ao_SubjectEditor, as_UserName, SUID, SGID);
					}
					
					
				}catch(DataNotFoundException ex){
					
					SubjectEditorDAO.Add(MyHSs, ao_SubjectEditor, as_UserName, SUID, SGID);
				}
			}
			return ao_SubjectEditor;
		}catch(Exception ex){
			throw ex;
		}
	}
}
