package esi.examwh.bl.examform;

import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.common.TYPE_ANSWER_STATUS;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAMINATION_STATUS;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;

import com.plw.util.DataNotFoundException;

public class ExamFormItemGenerator2 {
	
	public static String GenSQLExamFormItemAndExamFormItemGroupByExamFormID(int ai_CommandType,Integer ai_ExamScheduleDetailID,Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus, Integer SUID, Integer SGID,int... StatusList){
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ISNULL(EFI.EFI_ExamFormItemGroupID,-1) ExamFormItemGroupID ,EFI.ExamFormItemID ExamFormItemID ,EFI.EFI_VerifyExamItemStatus VerifyExamItemStatus, ");
			if(ae_ExamType != null){
//				if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
					sb_SQLCommand.append("SJ.SubjectID SubjectID , SJ.SJ_Code SubjectCode , UN.UN_Order UnitOrder,ST.ST_Order SectionOrder,OJ.OJ_Order ObjectiveOrder , ");
					sb_SQLCommand.append("EI.EI_DisableStatus DisableStatus , ");
				//}
			}
			sb_SQLCommand.append("EFI.EFI_Order ExamFormItemOrder ,EFI.EFI_Code Code,EFI.EFI_QuestionText Name,EFI.EFI_ExamType ExamType ,  ");
			sb_SQLCommand.append("EFI.EFI_GroupOrder GroupOrder ,EFI.EFI_DataStatus DataStatus , EFI.EFI_ExamStatus ExamStatus , EFI.EFI_ReOrderChoiceStatus ReOrderChoiceStatus , ");
			/////////////////////
			sb_SQLCommand.append("(SELECT COUNT(*) ");
			sb_SQLCommand.append("FROM ExamFormItem EFI2 ");
			sb_SQLCommand.append("WHERE EFI2.EFI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append("AND EFI2.EFI_CopiedExamItemID = EFI.EFI_CopiedExamItemID ");
			sb_SQLCommand.append("AND EFI2.EFI_ExamFormID IN (  " );
			sb_SQLCommand.append("SELECT EF.ExamFormID ");
				sb_SQLCommand.append("FROM ExamForm EF ");
				sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
				sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
				sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESD.ESD_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				if(ae_ListExaminationStatus.length ==1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus = "+ae_ListExaminationStatus[0].getValue()+" ");
				}else if(ae_ListExaminationStatus.length >1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  "+ae_ListExaminationStatus[0].getValue()+" ");
					for(int i = 1;i < ae_ListExaminationStatus.length;i++){
						sb_SQLCommand.append(" , ");
						sb_SQLCommand.append(ae_ListExaminationStatus[i].getValue());
					}
					sb_SQLCommand.append(" ) ");
				}
				if(ai_ExamScheduleDetailID != null){
					sb_SQLCommand.append("AND  EF.EF_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" " );
				}
				
			sb_SQLCommand.append(" )) ALREADYITEM ");
			//////////////////
			
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		if(ae_ExamType != null){
//			if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
				sb_SQLCommand.append("LEFT JOIN Subject SJ ON SJ.SubjectID = EFI.EFI_SubjectID ");
				sb_SQLCommand.append("LEFT JOIN Unit UN ON UN.UnitID = EFI.EFI_UnitID ");
				sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EFI.EFI_SectionID ");
				sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EFI.EFI_ObjectiveID ");
				sb_SQLCommand.append("LEFT JOIN ExamItem EI ON EI.ExamItemID = EFI.EFI_CopiedExamItemID ");
//			}
		}
		
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			if(ae_ExamType != null){
//				if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
//					sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
//				}else{
					sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
//				}
			}else{
				sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			}
			
			
		}
		return sb_SQLCommand.toString();
	}
	public static List<ExamFormItemResult> FindExamFormItemAndExamFormItemGroupByExamFormID(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindExamFormItemAndExamFormItemGroupByExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLExamFormItemAndExamFormItemGroupByExamFormID(20,ai_ExamScheduleDetailID,ai_ExamFormID,ae_ExamType,ae_ListExaminationStatus,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindExamFormItemAndExamFormItemGroupByExamFormID", ls_SQLCommand);
//			MyHSs.createSQLQuery(ls_SQLCommand).addScalar("Name", StandardBasicTypes.TEXT);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.examform.ExamFormItemResult.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new ExamFormItemResult());
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List<ExamFormItemResult> result = query.list();
//			List result = query.list();
			if (result.isEmpty() != true) {
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGenerator", "FindExamFormItemAndExamFormItemGroupByExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("FindExamFormItemAndExamFormItemGroupByExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
	public static int GetSizeExamFormItemAndExamFormItemGroupByExamFormID(Session MyHSs,Integer ai_ExamScheduleDetailID,Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeExamFormItemAndExamFormItemGroupByExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLExamFormItemAndExamFormItemGroupByExamFormID(10,ai_ExamScheduleDetailID,ai_ExamFormID,ae_ExamType,ae_ListExaminationStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeExamFormItemAndExamFormItemGroupByExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeExamFormItemAndExamFormItemGroupByExamFormID", "[" + RowCount.intValue() + "]  [END] @@@");
		return RowCount.intValue();
	}
	
	public static String GenSQLByExamFormIDExamTypeSortOrder(int ai_CommandType, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID, Integer SGID,int... StatusList) {
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EFI.EFI_Order ExamFormItemOrder, ExamFormItemID , EFI.EFI_Code Code, EFI.EFI_QuestionText Name, EFI.EFI_ExamStatus ExamStatus, EFI.EFI_NOFChoice NOFChoice, EFI.EFI_ObjectiveFormat ObjectiveFormat, EFI.EFI_ObjetiveAnswer ObjetiveAnswer ");
			sb_SQLCommand.append(",(SELECT EFIC.EFIC_DisplayOrder FROM ExamFormItemChoice EFIC WHERE EFIC.EFIC_ExamFormItemID = EFI.ExamFormItemID AND EFIC.EFIC_AnswerStatus = "+TYPE_ANSWER_STATUS.STATUS_ANSWER_CORRECT.getValue()+" ) RightChoice ");
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
		if(ae_ExamType != null){
			if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
				sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = EFI.EFI_UnitID ");
				sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EFI.EFI_SectionID ");
				sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EFI.EFI_ObjectiveID ");
			}
		}
		
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamFormID = "+ai_ExamFormID+" " );
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			if(ae_ExamType != null){
				if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
					sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
				}else{
					sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
				}
			}else{
				sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			}
			
			
		}
		return sb_SQLCommand.toString();
	}
	public static List<ExamFormItemResult> FindByExamFormIDExamTypeSortOrder(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "FindByExamFormItemID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormIDExamTypeSortOrder(20,ai_ExamFormID,ae_ExamType,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "FindByExamFormItemID", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.examform.ExamFormItemResult.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new ExamFormItemResult());
			
			
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List result = query.list();
			if (result.isEmpty() != true) {
				
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemChoiceGenerator", "FindByExamFormItemID", "[Not Found] @@@");
				throw new DataNotFoundException("FindByExamFormItemID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
	public static int GetSizeByExamFormIDExamTypeSortOrder(Session MyHSs, Integer ai_ExamFormID,TYPE_EXAM ae_ExamType ,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "GetSizeByExamFormItemID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormIDExamTypeSortOrder(10,ai_ExamFormID , ae_ExamType,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "GetSizeByExamFormItemID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemChoiceGenerator", "GetSizeByExamFormItemID", "[" + RowCount.intValue() + "]  [END] @@@");
		return RowCount.intValue();
	}
	public static void main(String[] args) {
		try{
//			TYPE_EXAMINATION_STATUS[] le_examinationStatus = new TYPE_EXAMINATION_STATUS[2];
//			le_examinationStatus[0] = TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_CREATE_EXAM;
//			le_examinationStatus[1] = TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_NEW;
//			System.out.println(GenSQLExamFormItemAndExamFormItemGroupByExamFormID(20, 123, 89, TYPE_EXAM.TYPE_OBJECTIVE, le_examinationStatus, null, null));
			Session MyHSs = ExamWHDaoUtil.getSession();
			System.out.println(GenSQLByExamFormIDExamTypeSortOrder(20, 89,TYPE_EXAM.TYPE_OBJECTIVE, null, null));
//			List<ExamFormItemResult> lo_ExamFormItemList = ExamFormItemGenerator2.FindByExamFormIDExamTypeSortOrder(MyHSs, 89, TYPE_EXAM.TYPE_OBJECTIVE, null, null, 0, 0);
			TYPE_EXAMINATION_STATUS[] le_examinationStatus = new TYPE_EXAMINATION_STATUS[2];
			le_examinationStatus[0] = TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_CREATE_EXAM;
			le_examinationStatus[1] = TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_NEW;
			List<ExamFormItemResult> lo_ExamFormItemList = ExamFormItemGenerator2.FindExamFormItemAndExamFormItemGroupByExamFormID(MyHSs, 147, 112, TYPE_EXAM.TYPE_OBJECTIVE, le_examinationStatus, null, null, 0, 0);
			for(int i = 0;i < lo_ExamFormItemList.size();i++){
				ExamFormItemResult lo_ExamFormItem = lo_ExamFormItemList.get(i);
				System.out.println("ExamFormItemID:"+lo_ExamFormItem.getExamFormItemID());
				System.out.println("ExamFormItemOrder:"+lo_ExamFormItem.getExamFormItemOrder());
				System.out.println("Code:"+lo_ExamFormItem.getCode());
				System.out.println("RightChoice:"+lo_ExamFormItem.getRightChoice());
			}
			MyHSs.close();
		}catch(Exception ex){
			
		}
	}
	public static String GenSQLExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID(int ai_CommandType,Integer ai_ExamScheduleDetailID,String as_ExamFormCode,Integer ai_SubjectID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_TopicID, Integer ai_ObjectiveID,String as_ExamFormItemCode,Integer ai_ExamFormItemOrder,TYPE_EXAM ae_ExamType,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,Integer ai_ExamFormID, Integer SUID, Integer SGID,int... StatusList){
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT ISNULL(EFI.EFI_ExamFormItemGroupID,-1) ExamFormItemGroupID ,EFI.ExamFormItemID ExamFormItemID ,EFI.EFI_CopiedExamItemID ExamItemID , ");
//			if(ae_ExamType != null){
//				if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
					sb_SQLCommand.append("SJ.SubjectID SubjectID , SJ.SJ_Code SubjectCode , UN.UN_Order UnitOrder,ST.ST_Order SectionOrder,OJ.OJ_Order ObjectiveOrder , ");
//				}
//			}
			sb_SQLCommand.append("EFI.EFI_Order ExamFormItemOrder ,EFI.EFI_Code Code,EFI.EFI_QuestionText Name,EFI.EFI_ExamType ExamType ,  ");
			sb_SQLCommand.append("EFI.EFI_GroupOrder GroupOrder ,EFI.EFI_DataStatus DataStatus , EFI.EFI_ExamStatus ExamStatus , EFI.EFI_ReOrderChoiceStatus ReOrderChoiceStatus , ");
			/////////////////////
			sb_SQLCommand.append("(SELECT COUNT(*) ");
			sb_SQLCommand.append("FROM ExamFormItem EFI2 ");
			sb_SQLCommand.append("WHERE EFI2.EFI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append("AND EFI2.EFI_CopiedExamItemID = EFI.EFI_CopiedExamItemID ");
			sb_SQLCommand.append("AND EFI2.EFI_ExamFormID IN (  " );
			sb_SQLCommand.append("SELECT EF.ExamFormID ");
				sb_SQLCommand.append("FROM ExamForm EF ");
				sb_SQLCommand.append("JOIN ExamScheduleDetail ESD ON ESD.ExamScheduleDetailID = EF.EF_ExamScheduleDetailID ");
				sb_SQLCommand.append("JOIN ExamSchedule ES ON ES.ExamScheduleID = ESD.ESD_CopiedExamScheduleID ");
				sb_SQLCommand.append("WHERE EF.EF_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append("AND ESD.ESD_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				sb_SQLCommand.append(") ");
				if(ae_ListExaminationStatus.length ==1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus = "+ae_ListExaminationStatus[0].getValue()+" ");
				}else if(ae_ListExaminationStatus.length >1){
					sb_SQLCommand.append("AND ES.ES_ExaminationStatus IN (  "+ae_ListExaminationStatus[0].getValue()+" ");
					for(int i = 1;i < ae_ListExaminationStatus.length;i++){
						sb_SQLCommand.append(" , ");
						sb_SQLCommand.append(ae_ListExaminationStatus[i].getValue());
					}
					sb_SQLCommand.append(" ) ");
				}
				if(ai_ExamScheduleDetailID != null){
					sb_SQLCommand.append("AND  EF.EF_ExamScheduleDetailID = "+ai_ExamScheduleDetailID+" " );
				}
			sb_SQLCommand.append(" )) ALREADYITEM ");
			//////////////////
			
		}
		sb_SQLCommand.append("FROM ExamFormItem EFI ");
//		if(ae_ExamType != null){
//			if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
				sb_SQLCommand.append("LEFT JOIN Subject SJ ON SJ.SubjectID = EFI.EFI_SubjectID ");
				sb_SQLCommand.append("LEFT JOIN Unit UN ON UN.UnitID = EFI.EFI_UnitID ");
				sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = EFI.EFI_SectionID ");
				sb_SQLCommand.append("LEFT JOIN Objective OJ ON OJ.ObjectiveID = EFI.EFI_ObjectiveID ");
//			}
//		}
		sb_SQLCommand.append("JOIN ExamForm EF2 ON EF2.ExamFormID = EFI.EFI_ExamFormID ");
		sb_SQLCommand.append("WHERE EFI.EFI_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(as_ExamFormCode != null){
			sb_SQLCommand.append("AND EF2.EF_Code Like '"+as_ExamFormCode+"' " );
		}
		if(ai_SubjectID != null){
			sb_SQLCommand.append("AND EFI.EFI_SubjectID = "+ai_SubjectID+" " );
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EFI.EFI_UnitID = "+ai_UnitID+" " );
		}
		if(ai_SectionID != null && ai_SectionID > 0){
			sb_SQLCommand.append("AND EFI.EFI_SectionID = "+ai_SectionID+" ");
		}else{
//			sb_SQLCommand.append("AND (EFI.EFI_SectionID = 0 OR EFI.EFI_SectionID IS NULL) ");
		}
		if(ai_TopicID != null){
			sb_SQLCommand.append("AND EFI.EFI_TopicID = "+ai_TopicID+" " );
		}
		if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND EFI.EFI_ObjectiveID = "+ai_ObjectiveID+" " );
		}
		if(ae_ExamType != null){
			sb_SQLCommand.append("AND EFI.EFI_ExamType = "+ae_ExamType.getValue()+" ");
		}
		if(as_ExamFormItemCode != null){
			sb_SQLCommand.append("AND EFI.EFI_Code Like '"+as_ExamFormItemCode+"' " );
		}
		if(ai_ExamFormItemOrder != null){
			sb_SQLCommand.append("AND EFI.EFI_Order = "+ai_ExamFormItemOrder+" " );
		}
		if(ai_ExamFormID != null){
			sb_SQLCommand.append("AND ( EFI.EFI_CopiedExamItemID NOT IN (SELECT EFI_Curr.EFI_CopiedExamItemID FROM ExamFormItem EFI_Curr WHERE EFI_Curr.EFI_ExamFormID = "+ai_ExamFormID+" AND EFI_Curr.EFI_DataStatus NOT IN ( 411, 511) AND EFI_Curr.EFI_CopiedExamItemID IS NOT NULL )  " );
			sb_SQLCommand.append("OR EFI.EFI_CopiedExamItemID IS NULL ) ");
		}
		if (ai_CommandType != 10) {
			if(ae_ExamType != null){
				if(ae_ExamType.getValue() == TYPE_EXAM.TYPE_OBJECTIVE.getValue()){
					sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
				}else{
					sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
				}
			}else{
				sb_SQLCommand.append("ORDER BY EFI.EFI_Order ");
			}
			
			
		}
		return sb_SQLCommand.toString();
	}
	public static List<ExamFormItemResult> FindByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID(Session MyHSs,Integer ai_ExamScheduleDetailID,String as_ExamFormCode,Integer ai_SubjectID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_TopicID, Integer ai_ObjectiveID,String as_ExamFormItemCode,Integer ai_ExamFormItemOrder,TYPE_EXAM ae_ExamType,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID(20,ai_ExamScheduleDetailID,as_ExamFormCode,ai_SubjectID,ai_UnitID,ai_SectionID,ai_TopicID,ai_ObjectiveID,as_ExamFormItemCode,ai_ExamFormItemOrder,ae_ExamType,ae_ListExaminationStatus,ai_ExamFormID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.examform.ExamFormItemResult.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new ExamFormItemResult());
			
			
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List result = query.list();
			if (result.isEmpty() != true) {
				
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGenerator", "FindByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID", "[Not Found] @@@");
				throw new DataNotFoundException("FindByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
	public static int GetSizeByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID(Session MyHSs,Integer ai_ExamScheduleDetailID,String as_ExamFormCode,Integer ai_SubjectID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_TopicID, Integer ai_ObjectiveID,String as_ExamFormItemCode,Integer ai_ExamFormItemOrder,TYPE_EXAM ae_ExamType,TYPE_EXAMINATION_STATUS[]  ae_ListExaminationStatus,Integer ai_ExamFormID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID(10,ai_ExamScheduleDetailID,as_ExamFormCode,ai_SubjectID,ai_UnitID,ai_SectionID,ai_TopicID,ai_ObjectiveID,as_ExamFormItemCode,ai_ExamFormItemOrder,ae_ExamType,ae_ListExaminationStatus,ai_ExamFormID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeByExamScheduleDetailIDExamFormCodeSubjectIDUnitIDSectionIDTopicIDObjectiveIDExamFormItemCodeExamFormItemOrderExamTypeExaminationStatusListFilterExamFormID", "[" + RowCount.intValue() + "]  [END] @@@");
		return RowCount.intValue();
	}
}
