package esi.examwh.bl.examform;

import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAM_GROUP;

import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;

public class ExamItemGroupResult  implements java.io.Serializable, ResultTransformer {
	private Integer ExamItemGroupID;
	private Integer SubjectID;
	private String SubjectCode;
	private Integer UnitOrder;
	private Integer SectionOrder;
	private String Code;
	private String Name;
	private Integer DataStatus;
	private Integer NOFExamItem;
	
	
	public Integer getExamItemGroupID() {
		return ExamItemGroupID;
	}
	public void setExamItemGroupID(Integer examItemGroupID) {
		ExamItemGroupID = examItemGroupID;
	}
	public Integer getSubjectID() {
		return SubjectID;
	}
	public void setSubjectID(Integer subjectID) {
		SubjectID = subjectID;
	}
	public String getSubjectCode() {
		return SubjectCode;
	}
	public void setSubjectCode(String subjectCode) {
		SubjectCode = subjectCode;
	}
	public Integer getUnitOrder() {
		return UnitOrder;
	}
	public void setUnitOrder(Integer unitOrder) {
		UnitOrder = unitOrder;
	}
	public Integer getSectionOrder() {
		return SectionOrder;
	}
	public void setSectionOrder(Integer sectionOrder) {
		SectionOrder = sectionOrder;
	}
	public String getCode() {
		return Code;
	}
	public void setCode(String code) {
		Code = code;
	}
	public String getName() {
		return Name;
	}
	public void setName(String name) {
		Name = name;
	}
	public Integer getDataStatus() {
		return DataStatus;
	}
	public void setDataStatus(Integer dataStatus) {
		DataStatus = dataStatus;
	}
	public Integer getNOFExamItem() {
		return NOFExamItem;
	}
	public void setNOFExamItem(Integer nOFExamItem) {
		NOFExamItem = nOFExamItem;
	}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamItemGroupID : "+ExamItemGroupID+ "]\n");
		temp.append("SubjectCode : "+SubjectCode+ "]\n");
		temp.append("UnitOrder : "+UnitOrder+ "]\n");
		temp.append("SectionOrder : "+SectionOrder+ "]\n");
		temp.append("Code : "+Code+ "]\n");
		temp.append("Name : "+Name+ "]\n");
		temp.append("DataStatus : "+DataStatus+ "]\n");
		temp.append("NOFExamItem : "+NOFExamItem+ "]\n");
		return temp.toString();
	}
	ResultTransformer aliasTransformer = Transformers.aliasToBean(ExamItemGroupResult.class);
	
	@Override
	public List transformList(List list) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformList", "[START] @@@");
		List<ExamItemGroupResult> result = aliasTransformer.transformList(list);
//		for(int i = 0;i < result.size();i++){
//			ExamItemGroupResult lo_ExamItemGroupResult = result.get(i);
//			result.get(i).setExamGroupTypeName(TYPE_EXAM_GROUP.getEnum(result.get(i).getExamGroupType()).getMessage());
//			if(lo_ExamItemGroupResult.getExamType() != -1){
//				result.get(i).setExamTypeName(TYPE_EXAM.getEnum(result.get(i).getExamType()).getMessage());
//			}
//		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformList", "[END] @@@");
        return result;
	}
	@Override
	public Object transformTuple(Object[] os, String[] strings) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformTuple", "[START] @@@");
		Object result = aliasTransformer.transformTuple(os, strings);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformTuple", "[END] @@@");
         return result;
	}
}
