package esi.examwh.bl.examform;

import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAM_GROUP;

import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;

public class ExamItemResult implements java.io.Serializable, ResultTransformer{
	private Integer ExamItemID;
	private Integer ExamItemIDParent;
	private Integer ExamGroupID;
	private Integer ExamItemOrder;
	private Integer UnitOrder;
	private String UnitName;
	private Integer SectionOrder;
	private String SectionName;
	private Integer ObjectiveOrder;
	private String ObjectiveName;
	private String Code;
	private String CodeParent;
	private String Name;
	private Integer ExamGroupType;
	private String ExamGroupTypeName;
	private Integer ExamType;
	private String ExamTypeName;
	private Integer GroupOrder;
	private Integer DataStatus;
	private Integer ExamStatus;
	private Integer ReOrderChoiceStatus;
	private Integer SelectedScore;
	private Integer ALREADYITEM;
	private Integer SubjectID;
	private String SubjectCode;
	private String NOFExamItem;
	private Integer NOFChoice;
	private Integer RightChoice;
	private Integer ObjectiveFormat;
	private Integer ObjetiveAnswer;
	private Integer BehaviorLevelID;
	private String BehaviorLevelName;
	private Integer ExamLevel;
	private Integer ExamScheduleDetailID;
	private Integer PersonID;
	private Integer ExamFormSelectedStatus;
	private Integer AllSelectedScore;
	private Integer VerifyExamItemStatus;
	private Integer LastUsedRound;
	private Integer LastUsedSemester;
	private Integer LastUsedYear;
	private Double ExamScore;
	private Integer MainSelector;
	public Integer getExamItemID() {
		return ExamItemID;
	}
	public void setExamItemID(Integer examItemID) {
		ExamItemID = examItemID;
	}
	public Integer getExamItemOrder() {
		return ExamItemOrder;
	}
	public void setExamItemOrder(Integer examItemOrder) {
		ExamItemOrder = examItemOrder;
	}
	public Integer getUnitOrder() {
		return UnitOrder;
	}
	public void setUnitOrder(Integer unitOrder) {
		UnitOrder = unitOrder;
	}
	public Integer getSectionOrder() {
		return SectionOrder;
	}
	public void setSectionOrder(Integer sectionOrder) {
		SectionOrder = sectionOrder;
	}
	public Integer getObjectiveOrder() {
		return ObjectiveOrder;
	}
	public void setObjectiveOrder(Integer objectiveOrder) {
		ObjectiveOrder = objectiveOrder;
	}
	public String getCode() {
		return Code;
	}
	public void setCode(String code) {
		Code = code;
	}
	public String getName() {
		return Name;
	}
	public void setName(String name) {
		Name = name;
	}
	public Integer getExamGroupType() {
		return ExamGroupType;
	}
	public void setExamGroupType(Integer examGroupType) {
		ExamGroupType = examGroupType;
	}
	public String getExamGroupTypeName() {
		return ExamGroupTypeName;
	}
	public void setExamGroupTypeName(String examGroupTypeName) {
		ExamGroupTypeName = examGroupTypeName;
	}
	public Integer getExamType() {
		return ExamType;
	}
	public void setExamType(Integer examType) {
		ExamType = examType;
	}
	public String getExamTypeName() {
		return ExamTypeName;
	}
	public void setExamTypeName(String examTypeName) {
		ExamTypeName = examTypeName;
	}
	public Integer getGroupOrder() {
		return GroupOrder;
	}
	public void setGroupOrder(Integer groupOrder) {
		GroupOrder = groupOrder;
	}
	public Integer getDataStatus() {
		return DataStatus;
	}
	public void setDataStatus(Integer dataStatus) {
		DataStatus = dataStatus;
	}
	public Integer getExamStatus() {
		return ExamStatus;
	}
	public void setExamStatus(Integer examStatus) {
		ExamStatus = examStatus;
	}
	public Integer getReOrderChoiceStatus() {
		return ReOrderChoiceStatus;
	}
	public void setReOrderChoiceStatus(Integer reOrderChoiceStatus) {
		ReOrderChoiceStatus = reOrderChoiceStatus;
	}
	public Integer getSelectedScore() {
		return SelectedScore;
	}
	public void setSelectedScore(Integer selectedScore) {
		SelectedScore = selectedScore;
	}
	public Integer getALREADYITEM() {
		return ALREADYITEM;
	}
	public void setALREADYITEM(Integer aLREADYITEM) {
		ALREADYITEM = aLREADYITEM;
	}
	public Integer getSubjectID() {
		return SubjectID;
	}
	public void setSubjectID(Integer subjectID) {
		SubjectID = subjectID;
	}
	public String getSubjectCode() {
		return SubjectCode;
	}
	public void setSubjectCode(String subjectCode) {
		SubjectCode = subjectCode;
	}
	public String getNOFExamItem() {
		return NOFExamItem;
	}
	public void setNOFExamItem(String nOFExamItem) {
		NOFExamItem = nOFExamItem;
	}
	public Integer getNOFChoice() {
		return NOFChoice;
	}
	public void setNOFChoice(Integer nOFChoice) {
		NOFChoice = nOFChoice;
	}
	public Integer getRightChoice() {
		return RightChoice;
	}
	public void setRightChoice(Integer rightChoice) {
		RightChoice = rightChoice;
	}
	public Integer getObjectiveFormat() {
		return ObjectiveFormat;
	}
	public void setObjectiveFormat(Integer objectiveFormat) {
		ObjectiveFormat = objectiveFormat;
	}
	public Integer getObjetiveAnswer() {
		return ObjetiveAnswer;
	}
	public void setObjetiveAnswer(Integer objetiveAnswer) {
		ObjetiveAnswer = objetiveAnswer;
	}
	public Integer getBehaviorLevelID() {
		return BehaviorLevelID;
	}
	public void setBehaviorLevelID(Integer behaviorLevelID) {
		BehaviorLevelID = behaviorLevelID;
	}
	public String getBehaviorLevelName() {
		return BehaviorLevelName;
	}
	public void setBehaviorLevelName(String behaviorLevelName) {
		BehaviorLevelName = behaviorLevelName;
	}
	public Integer getExamLevel() {
		return ExamLevel;
	}
	public void setExamLevel(Integer examLevel) {
		ExamLevel = examLevel;
	}
	public Integer getExamScheduleDetailID() {
		return ExamScheduleDetailID;
	}
	public void setExamScheduleDetailID(Integer examScheduleDetailID) {
		ExamScheduleDetailID = examScheduleDetailID;
	}
	public Integer getPersonID() {
		return PersonID;
	}
	public void setPersonID(Integer personID) {
		PersonID = personID;
	}
	public String getUnitName() {
		return UnitName;
	}
	public void setUnitName(String unitName) {
		UnitName = unitName;
	}
	public String getSectionName() {
		return SectionName;
	}
	public void setSectionName(String sectionName) {
		SectionName = sectionName;
	}
	public String getObjectiveName() {
		return ObjectiveName;
	}
	public void setObjectiveName(String objectiveName) {
		ObjectiveName = objectiveName;
	}
	public Integer getExamGroupID() {
		return ExamGroupID;
	}
	public void setExamGroupID(Integer examGroupID) {
		ExamGroupID = examGroupID;
	}
	public Integer getExamFormSelectedStatus() {
		return ExamFormSelectedStatus;
	}
	public void setExamFormSelectedStatus(Integer examFormSelectedStatus) {
		ExamFormSelectedStatus = examFormSelectedStatus;
	}
	public Integer getAllSelectedScore() {
		return AllSelectedScore;
	}
	public void setAllSelectedScore(Integer allSelectedScore) {
		AllSelectedScore = allSelectedScore;
	}
//	@Override
//	public List transformList(List arg0) {
//		// TODO Auto-generated method stub
//		return null;
//	}
//	@Override
//	public Object transformTuple(Object[] arg0, String[] arg1) {
//		// TODO Auto-generated method stub
//		return null;
//	}

	
ResultTransformer aliasTransformer = Transformers.aliasToBean(ExamItemResult.class);
	
	public Integer getLastUsedRound() {
	return LastUsedRound;
}
public void setLastUsedRound(Integer lastUsedRound) {
	LastUsedRound = lastUsedRound;
}
public Integer getLastUsedSemester() {
	return LastUsedSemester;
}
public void setLastUsedSemester(Integer lastUsedSemester) {
	LastUsedSemester = lastUsedSemester;
}
public Integer getLastUsedYear() {
	return LastUsedYear;
}
public void setLastUsedYear(Integer lastUsedYear) {
	LastUsedYear = lastUsedYear;
}
	public Integer getVerifyExamItemStatus() {
		return VerifyExamItemStatus;
	}
	public void setVerifyExamItemStatus(Integer verifyExamItemStatus) {
		VerifyExamItemStatus = verifyExamItemStatus;
	}
	public ResultTransformer getAliasTransformer() {
		return aliasTransformer;
	}
	public void setAliasTransformer(ResultTransformer aliasTransformer) {
		this.aliasTransformer = aliasTransformer;
	}
	@Override
	public List transformList(List list) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGenerator", "transformList", "[START] @@@");
		List<ExamItemResult> result = aliasTransformer.transformList(list);
		for(int i = 0;i < result.size();i++){
			ExamItemResult lo_ExamItemResult = result.get(i);
			result.get(i).setExamGroupTypeName(TYPE_EXAM_GROUP.getEnum(result.get(i).getExamGroupType()).getMessage());
			if(lo_ExamItemResult.getExamType() != -1){
				result.get(i).setExamTypeName(TYPE_EXAM.getEnum(result.get(i).getExamType()).getMessage());
			}
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGenerator", "transformList", "[END] @@@");
        return result;
	}
	@Override
	public Object transformTuple(Object[] os, String[] strings) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGenerator", "transformTuple", "[START] @@@");
		Object result = aliasTransformer.transformTuple(os, strings);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemGenerator", "transformTuple", "[END] @@@");
         return result;
	}
	public Double getExamScore() {
		return ExamScore;
	}
	public void setExamScore(Double examScore) {
		ExamScore = examScore;
	}
	public Integer getExamItemIDParent() {
		return ExamItemIDParent;
	}
	public void setExamItemIDParent(Integer examItemIDParent) {
		ExamItemIDParent = examItemIDParent;
	}
	public String getCodeParent() {
		return CodeParent;
	}
	public void setCodeParent(String codeParent) {
		CodeParent = codeParent;
	}
	public Integer getMainSelector() {
		return MainSelector;
	}
	public void setMainSelector(Integer mainSelector) {
		MainSelector = mainSelector;
	}
	
	
}
