package esi.examwh.bl.subjectformpolicy;

import java.util.ArrayList;
import java.util.List;

import esi.examwh.bl.examform.ExamFormItemResult;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM_GROUP;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;

import com.plw.util.DataNotFoundException;

public class GroupConditionGenerator {
	public static String GenSQLGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID(int ai_CommandType,Integer ai_SubjectFormPolicyDetailID, Integer SUID, Integer SGID,int... StatusList){
		StringBuffer sb_SQLCommand = new StringBuffer();
			sb_SQLCommand.append("SELECT UN.UN_Order UnitOrder,ST.ST_Order SectionOrder,SFPSD.SFPS_GroupNumber GroupNumber, SUM (SFPSD.SFPS_NOFItemRequire) NumberOfRequireItem ");
			sb_SQLCommand.append("FROM SubjectFormPolicySubDetail SFPSD ");
			sb_SQLCommand.append("JOIN Unit UN ON UN.UnitID = SFPSD.SFPS_UnitID ");
			sb_SQLCommand.append("LEFT JOIN Section ST ON ST.SectionID = SFPSD.SFPS_SectionID ");
			sb_SQLCommand.append("WHERE SFPSD.SFPS_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append("AND SFPSD.SFPS_SubjectFormPolicyDetailID = "+ai_SubjectFormPolicyDetailID+"  ");
			sb_SQLCommand.append("Group by UN.UN_Order,ST.ST_Order, SFPSD.SFPS_GroupNumber ");
			sb_SQLCommand.append("Order by UN.UN_Order,ST.ST_Order, SFPSD.SFPS_GroupNumber ");
		
		return sb_SQLCommand.toString();
	}
	public static List<GroupConditionResult> FindGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws Exception {
		List<GroupConditionResult> io_RPRL = new ArrayList<GroupConditionResult>(0);
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID(20,ai_SubjectFormPolicyDetailID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "FindGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.subjectformpolicy.GroupConditionResult.class));
			//Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(new GroupConditionResult());
			
			
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow); 
			}
			List result = query.list();
			if (result.isEmpty() != true) {
				
				return result;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamFormItemGenerator", "FindGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID", "[Not Found] @@@");
				throw new DataNotFoundException("FindGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
		
	}
//	public static int GetSizeGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID(Session MyHSs,Integer ai_SubjectFormPolicyDetailID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
//		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID", "[BEGIN] @@@");
//		String ls_SQLCommand = GenSQLGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID(10,ai_SubjectFormPolicyDetailID,SUID,SGID,StatusList);
//		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID", ls_SQLCommand);
//		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
//		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "GetSizeGroupNumberNumberOfRequireItemBySubjectFormPolicyDetailID", "[" + RowCount.intValue() + "]  [END] @@@");
//		return RowCount.intValue();
//	}
}
