package esi.examwh.bl.subjectformpolicy;

import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;

import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;

public class GroupConditionResult implements java.io.Serializable, ResultTransformer {
	private Integer UnitOrder;
	private Integer SectionOrder;
	private Integer GroupNumber;
	private Integer NumberOfRequireItem;
	
	
	public Integer getUnitOrder() {
		return UnitOrder;
	}
	public void setUnitOrder(Integer unitOrder) {
		UnitOrder = unitOrder;
	}
	public Integer getSectionOrder() {
		return SectionOrder;
	}
	public void setSectionOrder(Integer sectionOrder) {
		SectionOrder = sectionOrder;
	}
	public Integer getGroupNumber() {
		return GroupNumber;
	}
	public void setGroupNumber(Integer groupNumber) {
		GroupNumber = groupNumber;
	}
	public Integer getNumberOfRequireItem() {
		return NumberOfRequireItem;
	}
	public void setNumberOfRequireItem(Integer numberOfRequireItem) {
		NumberOfRequireItem = numberOfRequireItem;
	}
	ResultTransformer aliasTransformer = Transformers.aliasToBean(GroupConditionResult.class);
	
	@Override
	public List transformList(List list) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "GroupConditionGenerator", "transformList", "[START] @@@");
		List<GroupConditionResult> result = aliasTransformer.transformList(list);
		for(int i = 0;i < result.size();i++){
			GroupConditionResult lo_GroupConditionResult = result.get(i);
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "GroupConditionGenerator", "transformList", "[END] @@@");
        return result;
	}
	@Override
	public Object transformTuple(Object[] os, String[] strings) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "GroupConditionGenerator", "transformTuple", "[START] @@@");
		Object result = aliasTransformer.transformTuple(os, strings);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "GroupConditionGenerator", "transformTuple", "[END] @@@");
         return result;
	}

}
