package esi.examwh.model;

import javax.persistence.Column;
import javax.persistence.Embeddable;

@Embeddable
public class ESDItemSelectorPK implements java.io.Serializable {
	/**
	 * 
	 */
	private static final long serialVersionUID = -8583162278380081169L;
	private int ExamScheduleDetailID;
	private int PersonID;
	private int ExamLevel;

	public ESDItemSelectorPK() {
	}

	public ESDItemSelectorPK(int ExamScheduleDetailID, int PersonID, int ExamLevel) {
		this.ExamScheduleDetailID = ExamScheduleDetailID;
		this.PersonID = PersonID;
		this.ExamLevel = ExamLevel;
	}

	@Column(name = "ExamScheduleDetailID", nullable = false)
	public int getExamScheduleDetailID() {
		return this.ExamScheduleDetailID;
	}

	public void setExamScheduleDetailID(int ExamScheduleDetailID) {
		this.ExamScheduleDetailID = ExamScheduleDetailID;
	}

	@Column(name = "PersonID", nullable = false)
	public int getPersonID() {
		return this.PersonID;
	}

	public void setPersonID(int PersonID) {
		this.PersonID = PersonID;
	}
	
	@Column(name = "ExamLevel", nullable = true)
	public int getExamLevel() {
		return ExamLevel;
	}

	public void setExamLevel(int examLevel) {
		ExamLevel = examLevel;
	}
	public boolean equals(Object other) {
		if ((this == other))
			return true;
		if ((other == null))
			return false;
		if (!(other instanceof ESDItemSelectorPK))
			return false;
		ESDItemSelectorPK castOther = (ESDItemSelectorPK) other;

		return (this.getExamScheduleDetailID() == castOther
				.getExamScheduleDetailID())
				&& (this.getPersonID() == castOther.getPersonID())
						&& (this.getExamLevel() == castOther.getExamLevel());
	}

	public int hashCode() {
		int result = 17;

		result = 37 * result + this.getExamScheduleDetailID();
		result = 37 * result + this.getPersonID();
		result = 37 * result + this.getExamLevel();
		return result;
	}

	
	
}
