package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_CONDITION  implements PersistentEnum{
	TYPE_OBJECTIVE(10, "ข้อสอบปรนัย"), 
	TYPE_SUBJECTIVE(20, "ข้อสอบอัตนัย"),
	TYPE_UNDERLEVEL(30, "ข้อสอบระดับก่อนหน้า");

	private static final int[] StatusValue = { 10, 20 ,30};

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_CONDITION(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_CONDITION getEnum(int Data) {
		TYPE_CONDITION[] CheckList = TYPE_CONDITION.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_CONDITION.TYPE_OBJECTIVE;
	}

	public TYPE_CONDITION[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_CONDITION[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_CONDITION[] ResultList = new TYPE_CONDITION[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_CONDITION.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_CONDITION[0];
		} else {
			TYPE_CONDITION[] ResultList = new TYPE_CONDITION[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_CONDITION.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}
