package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_CONTENT  implements PersistentEnum{
	TYPE_CONTENT_WORD(10, "ข้อมูลเป็น Word"), 
	TYPE_CONTENT_PDF(20, "ข้อมูลเป็น PDF");

	private static final int[] StatusValue = { 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_CONTENT(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_CONTENT getEnum(int Data) {
		TYPE_CONTENT[] CheckList = TYPE_CONTENT.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_CONTENT.TYPE_CONTENT_WORD;
	}

	public TYPE_CONTENT[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_CONTENT[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_CONTENT[] ResultList = new TYPE_CONTENT[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_CONTENT.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_CONTENT[0];
		} else {
			TYPE_CONTENT[] ResultList = new TYPE_CONTENT[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_CONTENT.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}