package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_CREATED  implements PersistentEnum{
	TYPE_NORMAL(10, "สร้างแบบปกติ"), 
	TYPE_COPY(20, "สร้างโดยการสำเนาทั้งแบบทดสอบ"),
	TYPE_IMPORT_WALKIN(30, "สร้างโดยการนำเข้าจากระบบ WALK-IN EXAM");

	private static final int[] StatusValue = { 10, 20,30 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_CREATED(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_CREATED getEnum(int Data) {
		TYPE_CREATED[] CheckList = TYPE_CREATED.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_CREATED.TYPE_NORMAL;
	}

	public TYPE_CREATED[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_CREATED[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_CREATED[] ResultList = new TYPE_CREATED[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_CREATED.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_CREATED[0];
		} else {
			TYPE_CREATED[] ResultList = new TYPE_CREATED[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_CREATED.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}