package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_ENABLE_STATUS implements PersistentEnum {
	STATUS_NEW(0, "ใหม่"), 
	STATUS_ENABLE(100, "เปิดให้มีการสอบผ่านระบบ"),
	STATUS_DISABLE(200, "ไม่มีเปิดให้สอบผ่านระบบ");

	private static final int[] StatusValue = { 0, 100, 200 };

	private static final int[][] StatusFlow = { { 0, 0, 100 }, { 100, 100, 200 }, { 200, 200, 100} };

	private int Value;
	private String Message;

	private TYPE_ENABLE_STATUS(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_ENABLE_STATUS getEnum(int Data) {
		TYPE_ENABLE_STATUS[] CheckList = TYPE_ENABLE_STATUS.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_ENABLE_STATUS.STATUS_NEW;
	}

	public TYPE_ENABLE_STATUS[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_ENABLE_STATUS[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_ENABLE_STATUS[] ResultList = new TYPE_ENABLE_STATUS[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_ENABLE_STATUS.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_ENABLE_STATUS[0];
		} else {
			TYPE_ENABLE_STATUS[] ResultList = new TYPE_ENABLE_STATUS[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_ENABLE_STATUS.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}