package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAMFORM  implements PersistentEnum{
	TYPE_EXAMFORM_FOR_REAL(10, "แบบทดสอบสำหรับใช้สอบจริง"), 
	TYPE_EXAMFORM_FOR_TEST(20, "แบบทดสอบสำหรับทดสอบ");

	private static final int[] StatusValue = { 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAMFORM(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAMFORM getEnum(int Data) {
		TYPE_EXAMFORM[] CheckList = TYPE_EXAMFORM.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAMFORM.TYPE_EXAMFORM_FOR_TEST;
	}

	public TYPE_EXAMFORM[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAMFORM[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAMFORM[] ResultList = new TYPE_EXAMFORM[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAMFORM.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAMFORM[0];
		} else {
			TYPE_EXAMFORM[] ResultList = new TYPE_EXAMFORM[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAMFORM.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}