package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAMINATION  implements PersistentEnum{
	TYPE_EXAMINATION_PAPER(100, "การจัดสอบกระดาษ"), 
	TYPE_EXAMINATION_WALKIN(200, "การจัดสอบ WALK-IN");
//	TYPE_EXAMINATION_ETESTING(300, "การจัดสอบ e-Testing");
	private static final int[] StatusValue = { 100, 200};

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAMINATION(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAMINATION getEnum(int Data) {
		TYPE_EXAMINATION[] CheckList = TYPE_EXAMINATION.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAMINATION.TYPE_EXAMINATION_WALKIN;
	}

	public TYPE_EXAMINATION[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAMINATION[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAMINATION[] ResultList = new TYPE_EXAMINATION[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAMINATION.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAMINATION[0];
		} else {
			TYPE_EXAMINATION[] ResultList = new TYPE_EXAMINATION[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAMINATION.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}