package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAM_ITEM_SELECTED_STATUS implements PersistentEnum {
	TYPE_NOT_SELECT(10, "ไม่ถูกเลือก"), 
	TYPE_SELECTED(20, "ถูกเลือก");

	private static final int[] StatusValue = { 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAM_ITEM_SELECTED_STATUS(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAM_ITEM_SELECTED_STATUS getEnum(int Data) {
		TYPE_EXAM_ITEM_SELECTED_STATUS[] CheckList = TYPE_EXAM_ITEM_SELECTED_STATUS.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAM_ITEM_SELECTED_STATUS.TYPE_NOT_SELECT;
	}

	public TYPE_EXAM_ITEM_SELECTED_STATUS[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAM_ITEM_SELECTED_STATUS[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAM_ITEM_SELECTED_STATUS[] ResultList = new TYPE_EXAM_ITEM_SELECTED_STATUS[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAM_ITEM_SELECTED_STATUS.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAM_ITEM_SELECTED_STATUS[0];
		} else {
			TYPE_EXAM_ITEM_SELECTED_STATUS[] ResultList = new TYPE_EXAM_ITEM_SELECTED_STATUS[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAM_ITEM_SELECTED_STATUS.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}
