
package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_MAPPING_DATA implements PersistentEnum{
	TYPE_MAPPING_P_VALUE(10, "ตารางแปลผลค่า P"), 
	TYPE_MAPPING_R_VALUE(20, "ตารางแปลผลค่า R"),
	TYPE_MAPPING_P_AND_R_CORRECT_VALUE(30, "ตารางแปลผลค่า P และ R ตัวถูก"),
	TYPE_MAPPING_P_AND_R_LURE_VALUE(40,"ตารางแปลผลค่า P และ R ตัวลวง");
	private static final int[] StatusValue = { 10, 20, 30, 40};

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_MAPPING_DATA(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_MAPPING_DATA getEnum(int Data) {
		TYPE_MAPPING_DATA[] CheckList = TYPE_MAPPING_DATA.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_MAPPING_DATA.TYPE_MAPPING_P_VALUE;
	}

	public TYPE_MAPPING_DATA[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_MAPPING_DATA[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus.equals(StatusFlow[i][0])) {
					TYPE_MAPPING_DATA[] ResultList = new TYPE_MAPPING_DATA[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_MAPPING_DATA.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_MAPPING_DATA[0];
		} else {
			TYPE_MAPPING_DATA[] ResultList = new TYPE_MAPPING_DATA[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_MAPPING_DATA.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

}