package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_NOTIFY_MESSAGE  implements PersistentEnum{
	TYPE_NO_NOTIFY(10, "ไม่แสดงข้อความเกี่ยวกับเครื่องคำนวณ"), 
	TYPE_NOTIFY_DO_NOT_USE_CALCULATOR(20, "แสดงข้อความห้ามใช้เครื่องคำนวณ"),
	TYPE_NOTIFY_ALLOWED_TO_USE_CALCULATOR(30, "อนุญาตให้ใช้เครื่องคำนวณแบบธรรมดา"),
	TYPE_OTHER(900,"อื่นๆ");

	private static final int[] StatusValue = { 10, 20, 30, 900 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_NOTIFY_MESSAGE(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_NOTIFY_MESSAGE getEnum(int Data) {
		TYPE_NOTIFY_MESSAGE[] CheckList = TYPE_NOTIFY_MESSAGE.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_NOTIFY_MESSAGE.TYPE_NO_NOTIFY;
	}

	public TYPE_NOTIFY_MESSAGE[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_NOTIFY_MESSAGE[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_NOTIFY_MESSAGE[] ResultList = new TYPE_NOTIFY_MESSAGE[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_NOTIFY_MESSAGE.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_NOTIFY_MESSAGE[0];
		} else {
			TYPE_NOTIFY_MESSAGE[] ResultList = new TYPE_NOTIFY_MESSAGE[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_NOTIFY_MESSAGE.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

}