package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_PREFIX_DOCUMENT implements PersistentEnum{
	TYPE_EXAM_ITEM(10,"EI", "ข้อสอบ"),
	TYPE_EXAM_ITEM_CHOICE(20,"EIC", "ตัวเลือกข้อสอบ"),
	TYPE_EXAM_ITEM_GROUP(30,"C", "โจทย์ร่วม"),
	TYPE_EXAM_FORM(40,"EF","แบบทดสอบ");
	

	private static final String[] StatusValue = {};

	private int Value;
	private String Code;
	private String Message;

	private TYPE_PREFIX_DOCUMENT(int value,String code, String message) {
		this.Value = value;
		this.Code = code;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static String[] getStatusValue() {
		return StatusValue;
	}

	public void setValue(int value) {
		this.Value = value;
	}
	
	public String getCode() {
		return Code;
	}

	public void setCode(String code) {
		Code = code;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}
	
	public static TYPE_PREFIX_DOCUMENT getEnum(int Data) {
		TYPE_PREFIX_DOCUMENT[] CheckList = TYPE_PREFIX_DOCUMENT.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM;
	}
	public static TYPE_PREFIX_DOCUMENT getEnum(String Data) {
		TYPE_PREFIX_DOCUMENT[] CheckList = TYPE_PREFIX_DOCUMENT.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getCode().equals(Data)) {
				return CheckList[i];
			}
		}
		return TYPE_PREFIX_DOCUMENT.TYPE_EXAM_ITEM;
	}
}