package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_STATISTICS_USED  implements PersistentEnum{
	TYPE_UNUSE(0, "ไม่ใช้"), 
	TYPE_USE_FOR_P_R(10, "ค่า p และ r"),
	TYPE_USE_FOR_IRT(20, "ใช้ IRT");

	private static final int[] StatusValue = { 0, 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_STATISTICS_USED(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_STATISTICS_USED getEnum(int Data) {
		TYPE_STATISTICS_USED[] CheckList = TYPE_STATISTICS_USED.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_STATISTICS_USED.TYPE_UNUSE;
	}

	public TYPE_STATISTICS_USED[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_STATISTICS_USED[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_STATISTICS_USED[] ResultList = new TYPE_STATISTICS_USED[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_STATISTICS_USED.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_STATISTICS_USED[0];
		} else {
			TYPE_STATISTICS_USED[] ResultList = new TYPE_STATISTICS_USED[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_STATISTICS_USED.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}