package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_TMPCONDITION_STATUS implements PersistentEnum {
	
	STATUS_REAL(0, "ใช้งานจริง"), 
	STATUS_TEMPORARY(20, "ใช้งานชั่วคราว");

	private static final int[] StatusValue = { 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;
	
	private TYPE_TMPCONDITION_STATUS(int value, String message) {
		this.Value = value;
		this.Message = message;
	}
	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_TMPCONDITION_STATUS getEnum(int Data) {
		TYPE_TMPCONDITION_STATUS[] CheckList = TYPE_TMPCONDITION_STATUS.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_TMPCONDITION_STATUS.STATUS_REAL;
	}

	public TYPE_TMPCONDITION_STATUS[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_TMPCONDITION_STATUS[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_TMPCONDITION_STATUS[] ResultList = new TYPE_TMPCONDITION_STATUS[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_TMPCONDITION_STATUS.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_TMPCONDITION_STATUS[0];
		} else {
			TYPE_TMPCONDITION_STATUS[] ResultList = new TYPE_TMPCONDITION_STATUS[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_TMPCONDITION_STATUS.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}
