package esi.examwh.policy.core;

import java.io.IOException;
import java.util.PropertyResourceBundle;

import esi.examwh.model.common.TYPE_FLAG;
public class PolicyController {
	public static boolean VerifyData = false;
	public static boolean CommonLog = true;
	public static Integer ExamTimesPerYear = null;
	static {
		PropertyResourceBundle propResBundle;
		try {
			propResBundle = new PropertyResourceBundle(Thread.currentThread().getContextClassLoader().getResourceAsStream("config_policy_core.properties"));
			
			
			try{
				TYPE_FLAG lo_VerifyData = TYPE_FLAG.getEnum(Integer.parseInt(propResBundle.getString("VerifyData")));
				if( lo_VerifyData.getValue() == TYPE_FLAG.TYPE_YES.getValue()){
					VerifyData = true;
				}else{
					VerifyData = false;
				}
			}catch(Exception ex){
				ex.printStackTrace();
				VerifyData = false;
			}
			
			
			try{
				TYPE_FLAG lo_CommonLog = TYPE_FLAG.getEnum(Integer.parseInt(propResBundle.getString("CommonLog")));
				if( lo_CommonLog.getValue() == TYPE_FLAG.TYPE_YES.getValue()){
					CommonLog = true;
				}else{
					CommonLog = false;
				}
			}catch(Exception ex){
				ex.printStackTrace();
				CommonLog = false;
			}
			
			
			
			try{
				Integer li_ExamTimesPerYear = Integer.parseInt(propResBundle.getString("ExamTimesPerYear"));
				ExamTimesPerYear = li_ExamTimesPerYear;
			}catch(Exception ex){
				ex.printStackTrace();
				ExamTimesPerYear = null;
			}
		
		} catch (IOException e) {
			e.printStackTrace();
			VerifyData = false;
		}
	}
}
