package esi.examwh.testDAO;

import esi.examwh.dao.ExamRoundDAO;
import esi.examwh.dao.ExamSemesterDAO;
import esi.examwh.dao.ExamTimesDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.ExamRound;
import esi.examwh.model.ExamSemester;
import esi.examwh.model.ExamTimes;
import esi.examwh.model.ExamTimesPK;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class ExamTimesTestDAO {

	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_ExamRoundID = 1;
		Integer ai_ExamSemesterID = 1;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		ExamTimes newExamTimes = new ExamTimes();
		try {
			ExamTimesPK lo_PK = new ExamTimesPK();
			lo_PK.setExamRoundID(ai_ExamRoundID);
			lo_PK.setExamSemesterID(ai_ExamSemesterID);
			if(ai_ExamRoundID != null){
				ExamRound lo_ExamRound = ExamRoundDAO.GetByID(MyHSs,ai_ExamRoundID, null,null);
				newExamTimes.setOExamRoundID(lo_ExamRound);
				
			}
			if(ai_ExamSemesterID != null){
				ExamSemester lo_ExamSemester = ExamSemesterDAO.GetByID(MyHSs,ai_ExamSemesterID, null,null);
				newExamTimes.setOExamSemesterID(lo_ExamSemester);
			}
			
			
			newExamTimes.setPK(lo_PK);
			newExamTimes.setExamTimes(1);
			newExamTimes.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			ExamTimesDAO.Add(MyHSs,newExamTimes, "ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamTimesTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}
	public static void main(String[] args) {
		try {
			UTTestAdd();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
