package esi.examwh.bl;

import java.util.List;

import org.hibernate.Query;
import org.hibernate.Session;
import org.hibernate.transform.Transformers;

import com.plw.util.DataNotFoundException;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.common.PermissionService;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.common.TYPE_CONDITION;
import esi.examwh.model.common.TYPE_DATA_STATUS;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAM_ITEM_SELECTED_STATUS;

public class ExamItemConditionBL {
	public static String GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType(int ai_CommandType, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType, TYPE_EXAM ae_ExamType,Integer ai_PersonID, Integer SUID, Integer SGID,int... StatusList) {
		
			StringBuffer sb_SQLCommand = new StringBuffer();
			if (ai_CommandType == 10) {
				sb_SQLCommand.append("SELECT COUNT(*) ");
			} else {
				sb_SQLCommand.append("SELECT EICD.EICD_ExamFormConditionID ExamFormConditionID, EICD_BehaviorLevelID BehaviorLevelID, EICD_UnitID UnitID, EICD_SectionID SectionID, EICD_ObjectiveID ObjectiveID ");
				sb_SQLCommand.append(", ExamItemConditionID, EICD_NOFItem NOFItem, EICD_ConditionType ConditionType, EICD_DataStatus DataStatus ");
				//////////////////// NOF Item Seleted
				sb_SQLCommand.append(",( ");
				sb_SQLCommand.append("SELECT COUNT(*) ");
				sb_SQLCommand.append("FROM ExamItemSelected EIS ");
				sb_SQLCommand.append("JOIN ExamItem EI ON EI.ExamItemID = EIS.EIS_ExamItemID ");
				sb_SQLCommand.append(PermissionService.GetJoinString("EIS.EIS_OwnerGroupID", SUID, SGID));
				sb_SQLCommand.append("WHERE EIS.EIS_CreateTime IS NOT NULL ");
//				if(ai_ExamItemID != null){
//					sb_SQLCommand.append("AND ESDS.ESDS_ExamItemID = " + ai_ExamItemID+" ");
//				}
//				if(ai_ExamScheduleDetailID != null){
//					sb_SQLCommand.append("AND ESDS.ESDS_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
//				}
//				if(ai_RatingRoundID != null){
//					sb_SQLCommand.append("AND EIS.EIS_RatingRound = " + ai_RatingRoundID+" ");
//				}
				if(ai_BehaviorLevelID != null){
					sb_SQLCommand.append("AND EI.EI_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
				}
				if(ai_UnitID != null){
					sb_SQLCommand.append("AND EI.EI_UnitID = "+ai_UnitID+" ");
					sb_SQLCommand.append("AND EI.EI_SectionID IS NULL ");
					sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NULL ");
				}else if(ai_SectionID != null){
					sb_SQLCommand.append("AND EI.EI_SectionID = "+ai_SectionID+" ");
					sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NULL ");
				}else if(ai_ObjectiveID != null){
					sb_SQLCommand.append("AND EI.EI_ObjectiveID = "+ai_ObjectiveID+" ");
				}
				if(ai_PersonID != null){
					sb_SQLCommand.append("AND EIS.EIS_PersonID = " + ai_PersonID+" ");
				}
				if(ai_ExamFormConditionID != null){
					sb_SQLCommand.append("AND EIS.EIS_ExamFormConditionID = " + ai_ExamFormConditionID+" ");
				}
				if(ae_ExamType != null){
					sb_SQLCommand.append("AND EI.EI_ExamType = "+ae_ExamType.getValue()+" ");
				}
				sb_SQLCommand.append("AND EIS.EIS_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				if (StatusList.length > 0) {
					for (int i = 0; i < StatusList.length; i++) {
						sb_SQLCommand.append(", ");
						sb_SQLCommand.append(StatusList[i]);
					}
				}
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append(") NOFItemSelected ");
				
				////////////////////
				////////////////////NOF Total Item
				sb_SQLCommand.append(",( ");
				sb_SQLCommand.append("SELECT COUNT(*) ");
				sb_SQLCommand.append("FROM ExamItem EI2 ");
				sb_SQLCommand.append(PermissionService.GetJoinString("EIS.EIS_OwnerGroupID", SUID, SGID));
				sb_SQLCommand.append("WHERE EI2.EI_CreateTime IS NOT NULL ");
	
//				if(ai_ExamScheduleDetailID != null){
//					sb_SQLCommand.append("AND ESDS.ESDS_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
//				}
				if(ai_BehaviorLevelID != null){
					sb_SQLCommand.append("AND EI2.EI_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
				}
				if(ai_UnitID != null){
					sb_SQLCommand.append("AND EI2.EI_UnitID = "+ai_UnitID+" ");
					sb_SQLCommand.append("AND EI2.EI_SectionID IS NULL ");
					sb_SQLCommand.append("AND EI2.EI_ObjectiveID IS NULL ");
				}else if(ai_SectionID != null){
					sb_SQLCommand.append("AND EI2.EI_SectionID = "+ai_SectionID+" ");
					sb_SQLCommand.append("AND EI2.EI_ObjectiveID IS NULL ");
				}else if(ai_ObjectiveID != null){
					sb_SQLCommand.append("AND EI2.EI_ObjectiveID = "+ai_ObjectiveID+" ");
				}
				if(ae_ExamType != null){
					sb_SQLCommand.append("AND EI2.EI_ExamType = "+ae_ExamType.getValue()+" ");
				}
				sb_SQLCommand.append("AND EI2.EI_DataStatus NOT IN ( ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
				if (StatusList.length > 0) {
					for (int i = 0; i < StatusList.length; i++) {
						sb_SQLCommand.append(", ");
						sb_SQLCommand.append(StatusList[i]);
					}
				}
				sb_SQLCommand.append(") ");
				sb_SQLCommand.append(") NOFTotalItem ");
			
			////////////////////
			}
			sb_SQLCommand.append("FROM ExamItemCondition EICD ");
			sb_SQLCommand.append("WHERE EICD.EICD_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			if(ai_ExamFormConditionID != null){
				sb_SQLCommand.append("AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
			}
			if(ai_BehaviorLevelID != null){
				sb_SQLCommand.append("AND EICD.EICD_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
			}
			if(ai_UnitID != null){
				sb_SQLCommand.append("AND EICD.EICD_UnitID = "+ai_UnitID+" ");
				sb_SQLCommand.append("AND EICD.EICD_SectionID IS NULL ");
				sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
			}else if(ai_SectionID != null){
				sb_SQLCommand.append("AND EICD.EICD_SectionID = "+ai_SectionID+" ");
				sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
			}else if(ai_ObjectiveID != null){
				sb_SQLCommand.append("AND EICD.EICD_ObjectiveID = "+ai_ObjectiveID+" ");
			}
			if(ae_ConditionType != null){
				sb_SQLCommand.append("AND EICD.EICD_ConditionType = "+ae_ConditionType.getValue()+" ");
			}
			if (ai_CommandType != 10) {
				sb_SQLCommand.append("ORDER BY EICD.EICD_BehaviorLevelID ASC ");
			}
			return sb_SQLCommand.toString();
		}
		
	public static int GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType, TYPE_EXAM ae_ExamType,Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType", "[BEGIN] @@@");
		String ls_SQLCommand = GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType(10,ai_ExamFormConditionID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,ae_ExamType,ai_PersonID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType", ls_SQLCommand);
		Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType", "[" + RowCount.intValue() + "] Of ExamItemCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",BehaviorLevelID:"+ai_BehaviorLevelID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
		return RowCount.intValue();
	}
	
	public static List<ExamItemConditionResult> FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,TYPE_EXAM ae_ExamType,Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
		assert BeginRow < 0 : "BeginRow is less than 0";
		assert MaxRow < 0 : "MaxRow is less than 0";
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType", "[START] @@@");
		try {
			String ls_SQLCommand =  GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType(20,ai_ExamFormConditionID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,ae_ExamType,ai_PersonID,SUID,SGID,StatusList);
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType", ls_SQLCommand);
			Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.ExamItemConditionResult.class));
			query.setFirstResult(BeginRow);
			if (MaxRow > 0) {
				query.setMaxResults(MaxRow);
			}
			List<ExamItemConditionResult> ExamItemList = query.list();
			if (ExamItemList.isEmpty() != true) {
				return ExamItemList;
			} else {
				CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType", "[Not Found] @@@");
				throw new DataNotFoundException("Find ExamItem By FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType is not found.");
			}
		} catch (Exception ex) {
			ex.printStackTrace();
			throw ex;
		} finally {
		}
	}
	public static String GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus(int ai_CommandType, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer ai_PersonID,TYPE_EXAM_ITEM_SELECTED_STATUS ai_ExamItemSelectedStatus, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EICD.EICD_ExamFormConditionID ExamFormConditionID, EICD_BehaviorLevelID BehaviorLevelID, EICD_UnitID UnitID, EICD_SectionID SectionID, EICD_ObjectiveID ObjectiveID ");
			sb_SQLCommand.append(", ExamItemConditionID, EICD_NOFItem NOFItem, EICD_ConditionType ConditionType, EICD_DataStatus DataStatus ");
			////////////////////
			sb_SQLCommand.append(",( ");
			sb_SQLCommand.append("SELECT COUNT(*) ");
			sb_SQLCommand.append("FROM ExamItem EI ");
			sb_SQLCommand.append(PermissionService.GetJoinString("EI.EI_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE EI.EI_CreateTime IS NOT NULL ");
//			if(ai_ExamItemID != null){
//				sb_SQLCommand.append("AND ESDS.ESDS_ExamItemID = " + ai_ExamItemID+" ");
//			}
//			if(ai_ExamScheduleDetailID != null){
//				sb_SQLCommand.append("AND ESDS.ESDS_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
//			}
//			if(ai_RatingRoundID != null){
//				sb_SQLCommand.append("AND EIS.EIS_RatingRound = " + ai_RatingRoundID+" ");
//			}
			if(ai_BehaviorLevelID != null){
				sb_SQLCommand.append("AND EI.EI_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
			}
			if(ai_UnitID != null){
				sb_SQLCommand.append("AND EI.EI_UnitID = "+ai_UnitID+" ");
				sb_SQLCommand.append("AND EI.EI_SectionID IS NULL ");
				sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NULL ");
			}else if(ai_SectionID != null){
				sb_SQLCommand.append("AND EI.EI_SectionID = "+ai_SectionID+" ");
				sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NULL ");
			}else if(ai_ObjectiveID != null){
				sb_SQLCommand.append("AND EI.EI_ObjectiveID = "+ai_ObjectiveID+" ");
			}
			////////////////////////////
			if(ai_ExamItemSelectedStatus != null){
				if(ai_ExamItemSelectedStatus == TYPE_EXAM_ITEM_SELECTED_STATUS.TYPE_SELECTED){
					sb_SQLCommand.append(" AND EI.ExamItemID IN ");
				}else if(ai_ExamItemSelectedStatus == TYPE_EXAM_ITEM_SELECTED_STATUS.TYPE_NOT_SELECT){
					sb_SQLCommand.append(" AND EI.ExamItemID NOT IN ");
				}
					sb_SQLCommand.append(" (SELECT ESDS2.ESDS_ExamItemID FROM ExamFormSelected EFS ");
					sb_SQLCommand.append("JOIN ExamScheduleDetailSelected ESDS2 ON ESDS2.ExamScheduleDetailSelectedID = EFS.EFS_ExamScheduleDetailSelectedID ");
					sb_SQLCommand.append("JOIN ExamScheduleDetail ESD2 ON ESD2.ExamScheduleDetailID = ESDS2.ESDS_ExamScheduleDetailID ");
					sb_SQLCommand.append("WHERE ESDS2.ESDS_ExamScheduleDetailID = EI.EI_ExamScheduleDetailID ");
					
					if(ai_ExamFormConditionID != null){
						sb_SQLCommand.append(" AND EFS.EFS_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
					}
					sb_SQLCommand.append("AND EFS.EFS_DataStatus NOT IN (411,511)  ");
					sb_SQLCommand.append(")  ");
			}
			////////////////////////////
			sb_SQLCommand.append("AND EI.EI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append(") NOFItemSelected ");
			
			////////////////////
		}
		sb_SQLCommand.append("FROM ExamItemCondition EICD ");
		sb_SQLCommand.append("WHERE EICD.EICD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
		}
		if(ai_BehaviorLevelID != null){
			sb_SQLCommand.append("AND EICD.EICD_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EICD.EICD_UnitID = "+ai_UnitID+" ");
			sb_SQLCommand.append("AND EICD.EICD_SectionID IS NULL ");
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
		}else if(ai_SectionID != null){
			sb_SQLCommand.append("AND EICD.EICD_SectionID = "+ai_SectionID+" ");
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
		}else if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if(ae_ConditionType != null){
			sb_SQLCommand.append("AND EICD.EICD_ConditionType = "+ae_ConditionType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EICD.EICD_BehaviorLevelID ASC ");
		}
		return sb_SQLCommand.toString();
	}
	
public static int GetSizeByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer ai_PersonID,TYPE_EXAM_ITEM_SELECTED_STATUS ai_ExamItemSelectedStatus,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus", "[BEGIN] @@@");
	String ls_SQLCommand = GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus(10,ai_ExamFormConditionID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,ai_PersonID, ai_ExamItemSelectedStatus,SUID,SGID,StatusList);
	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus", ls_SQLCommand);
	Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus", "[" + RowCount.intValue() + "] Of ExamItemCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",BehaviorLevelID:"+ai_BehaviorLevelID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
	return RowCount.intValue();
}

public static List<ExamItemConditionResult> FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer ai_PersonID,TYPE_EXAM_ITEM_SELECTED_STATUS ai_ExamItemSelectedStatus,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
	assert BeginRow < 0 : "BeginRow is less than 0";
	assert MaxRow < 0 : "MaxRow is less than 0";
	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus", "[START] @@@");
	try {
		String ls_SQLCommand =  GenSQLByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus(20,ai_ExamFormConditionID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,ai_PersonID, ai_ExamItemSelectedStatus,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus", ls_SQLCommand);
		Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.ExamItemConditionResult.class));
		query.setFirstResult(BeginRow);
		if (MaxRow > 0) {
			query.setMaxResults(MaxRow);
		}
		List<ExamItemConditionResult> ExamItemList = query.list();
		if (ExamItemList.isEmpty() != true) {
			return ExamItemList;
		} else {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus", "[Not Found] @@@");
			throw new DataNotFoundException("Find ExamItem By FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypePersonIDExamItemSelectedStatus is not found.");
		}
	} catch (Exception ex) {
		ex.printStackTrace();
		throw ex;
	} finally {
	}
}
	public static void main(String[] args) {
		try{
			Session MyHSs = ExamWHDaoUtil.getSession();
			List<ExamItemConditionResult> ExamItemConditionList = ExamItemConditionBL.FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionTypeExamType(MyHSs, 31, 2, 1412, null, null, TYPE_CONDITION.TYPE_OBJECTIVE,TYPE_EXAM.TYPE_OBJECTIVE,140,null,null, 0, 0);
			for(int i=0;i<ExamItemConditionList.size();i++){
				System.out.println(ExamItemConditionList.get(i).toString());
			}
		}catch(Exception ex){
			
		}
	}
	///////////////////////////////////
	public static String GenSQLByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(int ai_CommandType, Integer ai_ExamFormConditionID, Integer ai_ExamScheduleDetailID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer ai_PersonID, Integer SUID, Integer SGID,int... StatusList) {
		
		StringBuffer sb_SQLCommand = new StringBuffer();
		if (ai_CommandType == 10) {
			sb_SQLCommand.append("SELECT COUNT(*) ");
		} else {
			sb_SQLCommand.append("SELECT EICD.EICD_ExamFormConditionID ExamFormConditionID, EICD_BehaviorLevelID BehaviorLevelID, EICD_UnitID UnitID, EICD_SectionID SectionID, EICD_ObjectiveID ObjectiveID ");
			sb_SQLCommand.append(", ExamItemConditionID, EICD_NOFItem NOFItem, EICD_ConditionType ConditionType, EICD_DataStatus DataStatus ");
			////////////////////
			sb_SQLCommand.append(",( ");
			sb_SQLCommand.append("SELECT COUNT(*) ");
			sb_SQLCommand.append("FROM ExamItem EI ");
			sb_SQLCommand.append(PermissionService.GetJoinString("EI.EI_OwnerGroupID", SUID, SGID));
			sb_SQLCommand.append("WHERE EI.EI_CreateTime IS NOT NULL ");
//			if(ai_ExamItemID != null){
//				sb_SQLCommand.append("AND ESDS.ESDS_ExamItemID = " + ai_ExamItemID+" ");
//			}
//			if(ai_ExamScheduleDetailID != null){
//				sb_SQLCommand.append("AND ESDS.ESDS_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
//			}
//			if(ai_RatingRoundID != null){
//				sb_SQLCommand.append("AND EIS.EIS_RatingRound = " + ai_RatingRoundID+" ");
//			}
			if(ai_BehaviorLevelID != null){
				sb_SQLCommand.append("AND EI.EI_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
			}
			if(ai_UnitID != null){
				sb_SQLCommand.append("AND EI.EI_UnitID = "+ai_UnitID+" ");
				sb_SQLCommand.append("AND EI.EI_SectionID IS NULL ");
				sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NULL ");
			}else if(ai_SectionID != null){
				sb_SQLCommand.append("AND EI.EI_SectionID = "+ai_SectionID+" ");
				sb_SQLCommand.append("AND EI.EI_ObjectiveID IS NULL ");
			}else if(ai_ObjectiveID != null){
				sb_SQLCommand.append("AND EI.EI_ObjectiveID = "+ai_ObjectiveID+" ");
			}
			if(ai_PersonID != null){
				sb_SQLCommand.append("AND EI.EI_ExamCreator = " + ai_PersonID+" ");
			}
			if(ai_ExamScheduleDetailID != null){
				sb_SQLCommand.append("AND EI.EI_ExamScheduleDetailID = " + ai_ExamScheduleDetailID+" ");
			}
			sb_SQLCommand.append("AND EI.EI_DataStatus NOT IN ( ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
			sb_SQLCommand.append(", ");
			sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
			if (StatusList.length > 0) {
				for (int i = 0; i < StatusList.length; i++) {
					sb_SQLCommand.append(", ");
					sb_SQLCommand.append(StatusList[i]);
				}
			}
			sb_SQLCommand.append(") ");
			sb_SQLCommand.append(") NOFItemCreated ");
			
			////////////////////
		}
		sb_SQLCommand.append("FROM ExamItemCondition EICD ");
		sb_SQLCommand.append("WHERE EICD.EICD_DataStatus NOT IN ( ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DISABLE.getValue());
		sb_SQLCommand.append(", ");
		sb_SQLCommand.append(TYPE_DATA_STATUS.STATUS_DELETE.getValue());
		if (StatusList.length > 0) {
			for (int i = 0; i < StatusList.length; i++) {
				sb_SQLCommand.append(", ");
				sb_SQLCommand.append(StatusList[i]);
			}
		}
		sb_SQLCommand.append(") ");
		if(ai_ExamFormConditionID != null){
			sb_SQLCommand.append("AND EICD.EICD_ExamFormConditionID = "+ai_ExamFormConditionID+" ");
		}
		if(ai_BehaviorLevelID != null){
			sb_SQLCommand.append("AND EICD.EICD_BehaviorLevelID = "+ai_BehaviorLevelID+" ");
		}
		if(ai_UnitID != null){
			sb_SQLCommand.append("AND EICD.EICD_UnitID = "+ai_UnitID+" ");
			sb_SQLCommand.append("AND EICD.EICD_SectionID IS NULL ");
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
		}else if(ai_SectionID != null){
			sb_SQLCommand.append("AND EICD.EICD_SectionID = "+ai_SectionID+" ");
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID IS NULL ");
		}else if(ai_ObjectiveID != null){
			sb_SQLCommand.append("AND EICD.EICD_ObjectiveID = "+ai_ObjectiveID+" ");
		}
		if(ae_ConditionType != null){
			sb_SQLCommand.append("AND EICD.EICD_ConditionType = "+ae_ConditionType.getValue()+" ");
		}
		if (ai_CommandType != 10) {
			sb_SQLCommand.append("ORDER BY EICD.EICD_BehaviorLevelID ASC ");
		}
		return sb_SQLCommand.toString();
	}
	
public static int GetSizeByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_ExamScheduleDetailID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer ai_PersonID,Integer SUID, Integer SGID,int... StatusList) throws DataNotFoundException, Exception {
	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", "[BEGIN] @@@");
	String ls_SQLCommand = GenSQLByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(10,ai_ExamFormConditionID,ai_ExamScheduleDetailID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,ai_PersonID,SUID,SGID,StatusList);
	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
	Integer RowCount = (Integer) MyHSs.createSQLQuery(ls_SQLCommand).uniqueResult();
	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionDAO", "GetSizeByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", "[" + RowCount.intValue() + "] Of ExamItemCondition By ExamFormConditionID:"+ai_ExamFormConditionID+",BehaviorLevelID:"+ai_BehaviorLevelID+",UnitID:"+ai_UnitID+",SectionID:"+ai_SectionID+",ObjectiveID:"+ai_ObjectiveID+" [END] @@@");
	return RowCount.intValue();
}

public static List<ExamItemConditionResult> FindByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(Session MyHSs, Integer ai_ExamFormConditionID, Integer ai_ExamScheduleDetailID, Integer ai_BehaviorLevelID,Integer ai_UnitID,Integer ai_SectionID,Integer ai_ObjectiveID,TYPE_CONDITION ae_ConditionType,Integer ai_PersonID,Integer SUID,Integer SGID, int BeginRow, int MaxRow,int... StatusList) throws DataNotFoundException, Exception {
	assert BeginRow < 0 : "BeginRow is less than 0";
	assert MaxRow < 0 : "MaxRow is less than 0";
	CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "FindByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", "[START] @@@");
	try {
		String ls_SQLCommand =  GenSQLByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType(20,ai_ExamFormConditionID,ai_ExamScheduleDetailID,ai_BehaviorLevelID,ai_UnitID,ai_SectionID,ai_ObjectiveID,ae_ConditionType,ai_PersonID,SUID,SGID,StatusList);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "FindByExamFormConditionIDExamScheduleDetailIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", ls_SQLCommand);
		Query query = MyHSs.createSQLQuery(ls_SQLCommand).setResultTransformer(Transformers.aliasToBean(esi.examwh.bl.ExamItemConditionResult.class));
		query.setFirstResult(BeginRow);
		if (MaxRow > 0) {
			query.setMaxResults(MaxRow);
		}
		List<ExamItemConditionResult> ExamItemList = query.list();
		if (ExamItemList.isEmpty() != true) {
			return ExamItemList;
		} else {
			CommonLog.Print(LOG_LEVEL.ERROR_LEVEL, "ExamItemConditionDAO", "FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType", "[Not Found] @@@");
			throw new DataNotFoundException("Find ExamItem By FindByExamFormConditionIDBehaviorLevelIDUnitIDSectionIDObjectiveIDConditionType is not found.");
		}
	} catch (Exception ex) {
		ex.printStackTrace();
		throw ex;
	} finally {
	}
}
}
