package esi.examwh.bl;

import java.util.List;

import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;

import esi.examwh.bl.examform.ExamFormItemChoiceResult;
import esi.examwh.bl.examform.ExamItemResult;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAM_GROUP;

public class ExamItemConditionResult implements java.io.Serializable, ResultTransformer{
	/**
	 * 
	 */
	private static final long serialVersionUID = 1L;
	private Integer ExamFormConditionID;
	private Integer BehaviorLevelID;
	private Integer UnitID;
	private Integer SectionID;
	private Integer ObjectiveID;
	private Integer ExamItemConditionID;
	
	private Integer NOFItem;
	private Double ExamScore;
	private Integer ConditionType;
	
	private int DataStatus;
	private Integer NOFItemSelected;
	private Integer NOFItemCreated;
	private Integer NOFTotalItem;
	ResultTransformer aliasTransformer = Transformers.aliasToBean(ExamItemConditionResult.class);
	@Override
	public List transformList(List list) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "transformList", "[START] @@@");
		List<ExamItemConditionResult> result = aliasTransformer.transformList(list);
		
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "transformList", "[END] @@@");
        return result;
	}
	@Override
	public Object transformTuple(Object[] os, String[] strings) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "transformTuple", "[START] @@@");
		Object result = aliasTransformer.transformTuple(os, strings);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamItemConditionGenerator", "transformTuple", "[END] @@@");
         return result;
	}

	public Integer getExamFormConditionID() {
		return ExamFormConditionID;
	}

	public void setExamFormConditionID(Integer examFormConditionID) {
		ExamFormConditionID = examFormConditionID;
	}

	public Integer getBehaviorLevelID() {
		return BehaviorLevelID;
	}

	public void setBehaviorLevelID(Integer behaviorLevelID) {
		BehaviorLevelID = behaviorLevelID;
	}

	public Integer getUnitID() {
		return UnitID;
	}

	public void setUnitID(Integer unitID) {
		UnitID = unitID;
	}

	public Integer getSectionID() {
		return SectionID;
	}

	public void setSectionID(Integer sectionID) {
		SectionID = sectionID;
	}

	public Integer getObjectiveID() {
		return ObjectiveID;
	}

	public void setObjectiveID(Integer objectiveID) {
		ObjectiveID = objectiveID;
	}

	public Integer getExamItemConditionID() {
		return ExamItemConditionID;
	}

	public void setExamItemConditionID(Integer examItemConditionID) {
		ExamItemConditionID = examItemConditionID;
	}

	public Integer getNOFItem() {
		return NOFItem;
	}

	public void setNOFItem(Integer nOFItem) {
		NOFItem = nOFItem;
	}

	public Double getExamScore() {
		return ExamScore;
	}

	public void setExamScore(Double examScore) {
		ExamScore = examScore;
	}

	public Integer getConditionType() {
		return ConditionType;
	}

	public void setConditionType(Integer conditionType) {
		ConditionType = conditionType;
	}

	public int getDataStatus() {
		return DataStatus;
	}

	public void setDataStatus(int dataStatus) {
		DataStatus = dataStatus;
	}
	
	public Integer getNOFItemSelected() {
		return NOFItemSelected;
	}
	public void setNOFItemSelected(Integer nOFItemSelected) {
		NOFItemSelected = nOFItemSelected;
	}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamFormConditionID :["+this.ExamFormConditionID+"]\n");
		temp.append("///////////////////////[Begin Record]\n");
		temp.append("BehaviorLevelID : ["+this.BehaviorLevelID+"]\n");
		temp.append("UnitID : ["+this.UnitID+"]\n");
		temp.append("SectionID : ["+this.SectionID+"]\n");
		temp.append("ObjectiveID : ["+this.ObjectiveID+"]\n");
		temp.append("ExamItemConditionID : ["+this.ExamItemConditionID+"]\n");
		temp.append("NOFItem : ["+this.NOFItem+"]\n");
		temp.append("ExamScore : ["+this.ExamScore+"]\n");
		temp.append("ConditionType : ["+this.ConditionType+"]\n");
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("NOFItemSelected : ["+this.NOFItemSelected+"]\n");
		temp.append("/////////////////////[End Record]");
		return temp.toString();
	}
	public Integer getNOFItemCreated() {
		return NOFItemCreated;
	}
	public void setNOFItemCreated(Integer nOFItemCreated) {
		NOFItemCreated = nOFItemCreated;
	}
	public Integer getNOFTotalItem() {
		return NOFTotalItem;
	}
	public void setNOFTotalItem(Integer nOFTotalItem) {
		NOFTotalItem = nOFTotalItem;
	}
	
}
