package esi.examwh.bl;

import esi.examwh.dao.SubjectCollatorDAO;
import esi.examwh.dao.common.RequestParameterException;
import esi.examwh.model.Person;
import esi.examwh.model.Subject;
import esi.examwh.model.SubjectCollator;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;

import com.plw.util.DataNotFoundException;

public class SubjectCollatorBL {
	public static SubjectCollator Add(Session MyHSs,SubjectCollator ao_SubjectCollator, String as_UserName, Integer SUID, Integer SGID) throws Exception {
		try{
			Person lo_Person  = ao_SubjectCollator.getOPersonID();
			Subject lo_Subject = ao_SubjectCollator.getOSubjectID();
			if(lo_Person != null && lo_Subject != null){
				try{
					Integer li_SubjectID = lo_Subject.getSubjectID();
					Integer li_PersonID = lo_Person.getPersonID();
					SubjectCollator lo_SubjectCollator = SubjectCollatorDAO.GetByID(MyHSs, li_SubjectID, li_PersonID, SUID, SGID);
					if(lo_SubjectCollator != null){
						if(lo_SubjectCollator.getDataStatus() == TYPE_DATA_STATUS.STATUS_DISABLE){
							lo_SubjectCollator.setDataStatus(ao_SubjectCollator.getDataStatus());
							lo_SubjectCollator.setOrder(ao_SubjectCollator.getOrder());
							SubjectCollatorDAO.Modify(MyHSs,lo_SubjectCollator, as_UserName, SUID, SGID);
							ao_SubjectCollator = lo_SubjectCollator;
						}else{
							throw new RequestParameterException("SubjectID [SubjectID:" + li_SubjectID +",PersonID:"+li_PersonID+ "] is not found.");
						}
					}else{
						SubjectCollatorDAO.Add(MyHSs, ao_SubjectCollator, as_UserName, SUID, SGID);
					}
					
					
				}catch(DataNotFoundException ex){
					SubjectCollatorDAO.Add(MyHSs, ao_SubjectCollator, as_UserName, SUID, SGID);
				}
			}
			return ao_SubjectCollator;
		}catch(Exception ex){
			throw ex;
		}
	}
}
