package esi.examwh.bl.curriculum;

import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;

import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;

public class ExamAttributeResult implements java.io.Serializable, ResultTransformer {
	
	private Integer CurriculumAttributeID; 
	private Integer AttributeOrder;
	private Integer ExamItemAttributeID;
	private Integer IndicatorLevel;
	private Integer AttributeID;
	private Integer NOFIndicators;
	private String AttributeName;


	public Integer getCurriculumAttributeID() {
		return CurriculumAttributeID;
	}

	public void setCurriculumAttributeID(Integer curriculumAttributeID) {
		CurriculumAttributeID = curriculumAttributeID;
	}

	public Integer getAttributeOrder() {
		return AttributeOrder;
	}

	public void setAttributeOrder(Integer attributeOrder) {
		AttributeOrder = attributeOrder;
	}

	public Integer getExamItemAttributeID() {
		return ExamItemAttributeID;
	}

	public void setExamItemAttributeID(Integer examItemAttributeID) {
		ExamItemAttributeID = examItemAttributeID;
	}

	public Integer getIndicatorLevel() {
		return IndicatorLevel;
	}

	public void setIndicatorLevel(Integer indicatorLevel) {
		IndicatorLevel = indicatorLevel;
	}

	public Integer getAttributeID() {
		return AttributeID;
	}

	public void setAttributeID(Integer attributeID) {
		AttributeID = attributeID;
	}

	public Integer getNOFIndicators() {
		return NOFIndicators;
	}

	public void setNOFIndicators(Integer nOFIndicators) {
		NOFIndicators = nOFIndicators;
	}

	public String getAttributeName() {
		return AttributeName;
	}

	public void setAttributeName(String attributeName) {
		AttributeName = attributeName;
	}
ResultTransformer aliasTransformer = Transformers.aliasToBean(ExamAttributeResult.class);
	
	@Override
	public List transformList(List list) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAttributeGenerator", "transformList", "[START] @@@");
		List<ExamAttributeResult> result = aliasTransformer.transformList(list);
		for(int i = 0;i < result.size();i++){
			ExamAttributeResult lo_ExamAttributeResult = result.get(i);
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAttributeGenerator", "transformList", "[END] @@@");
        return result;
	}
	@Override
	public Object transformTuple(Object[] os, String[] strings) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAttributeGenerator", "transformTuple", "[START] @@@");
		Object result = aliasTransformer.transformTuple(os, strings);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamAttributeGenerator", "transformTuple", "[END] @@@");
         return result;
	}
}
