package esi.examwh.bl.examform;

import java.sql.Blob;
import java.util.Date;
import java.util.List;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.ExamFormItem;
import esi.examwh.model.ExamItemChoice;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAM_GROUP;

import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;

public class ExamFormItemChoiceResult implements java.io.Serializable, ResultTransformer {
	
	private Integer ExamFormItemChoiceID;
	private Integer ExamItemChoiceID;
	private Integer ExamFormItemID;
	private int Order;
	private String Code;
	private Integer DisplayOrder;
	private Double PValue;
	private Double RValue;
	private String ChoiceText;
	private Blob ChoiceWord;
	private Blob ChoiceImage;
	private Integer AnswerStatus;
	private int DataStatus;
	
	
	public Integer getExamFormItemChoiceID() {
		return ExamFormItemChoiceID;
	}
	public void setExamFormItemChoiceID(Integer examFormItemChoiceID) {
		ExamFormItemChoiceID = examFormItemChoiceID;
	}
	public Integer getExamItemChoiceID() {
		return ExamItemChoiceID;
	}
	public void setExamItemChoiceID(Integer examItemChoiceID) {
		ExamItemChoiceID = examItemChoiceID;
	}
	public Integer getExamFormItemID() {
		return ExamFormItemID;
	}
	public void setExamFormItemID(Integer examFormItemID) {
		ExamFormItemID = examFormItemID;
	}
	public int getOrder() {
		return Order;
	}
	public void setOrder(int order) {
		Order = order;
	}
	public String getCode() {
		return Code;
	}
	public void setCode(String code) {
		Code = code;
	}
	public Integer getDisplayOrder() {
		return DisplayOrder;
	}
	public void setDisplayOrder(Integer displayOrder) {
		DisplayOrder = displayOrder;
	}
	public Double getPValue() {
		return PValue;
	}
	public void setPValue(Double pValue) {
		PValue = pValue;
	}
	public Double getRValue() {
		return RValue;
	}
	public void setRValue(Double rValue) {
		RValue = rValue;
	}
	public String getChoiceText() {
		return ChoiceText;
	}
	public void setChoiceText(String choiceText) {
		ChoiceText = choiceText;
	}
	public Blob getChoiceWord() {
		return ChoiceWord;
	}
	public void setChoiceWord(Blob choiceWord) {
		ChoiceWord = choiceWord;
	}
	public Blob getChoiceImage() {
		return ChoiceImage;
	}
	public void setChoiceImage(Blob choiceImage) {
		ChoiceImage = choiceImage;
	}
	public Integer getAnswerStatus() {
		return AnswerStatus;
	}
	public void setAnswerStatus(Integer answerStatus) {
		AnswerStatus = answerStatus;
	}
	public int getDataStatus() {
		return DataStatus;
	}
	public void setDataStatus(int dataStatus) {
		DataStatus = dataStatus;
	}
	ResultTransformer aliasTransformer = Transformers.aliasToBean(ExamFormItemChoiceResult.class);
	@Override
	public List transformList(List list) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformList", "[START] @@@");
		List<ExamFormItemChoiceResult> result = aliasTransformer.transformList(list);
		
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformList", "[END] @@@");
        return result;
	}
	@Override
	public Object transformTuple(Object[] os, String[] strings) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformTuple", "[START] @@@");
		Object result = aliasTransformer.transformTuple(os, strings);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformTuple", "[END] @@@");
         return result;
	}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamFormItemChoiceID :["+this.ExamFormItemChoiceID+"]\n");
		temp.append("///////////////////////[Begin Record]\n");
		temp.append("ExamItemChoiceID : ["+this.getExamItemChoiceID()+"]\n");
		temp.append("ExamFormItemID : ["+this.getExamFormItemID()+"]\n");
		temp.append("Order : ["+this.Order+"]\n");
		temp.append("Code : ["+this.Code+"]\n");
		temp.append("DisplayOrder : ["+this.DisplayOrder+"]\n");
		temp.append("PValue : ["+this.PValue+"]\n");
		temp.append("RValue : ["+this.RValue+"]\n");
		temp.append("ChoiceText : ["+this.ChoiceText+"]\n");
		temp.append("ChoiceImage : ["+this.ChoiceImage+"]\n");
		temp.append("ChoiceWord : ["+this.ChoiceWord+"]\n");
		temp.append("AnswerStatus : ["+this.AnswerStatus+"]\n");
		temp.append("DataStatus : ["+this.DataStatus+"]\n");
		temp.append("/////////////////////[End Record]");
		return temp.toString();
	}
}
