package esi.examwh.bl.examform;

import java.util.List;

import javax.persistence.Column;

import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.model.common.TYPE_EXAM;
import esi.examwh.model.common.TYPE_EXAM_GROUP;

import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;


public class ExamFormItemResult implements java.io.Serializable, ResultTransformer {
	private Integer ExamItemID;
	private Integer ExamFormItemID;
	private Integer ExamFormItemGroupID;
	private Integer ExamFormItemOrder;
	private Integer UnitOrder;
	private Integer SectionOrder;
	private Integer ObjectiveOrder;
	private String Code;
	private String Name;
	private Integer ExamGroupType;
	private String ExamGroupTypeName;
	private Integer ExamType;
	private String ExamTypeName;
	private Integer GroupOrder;
	private Integer DataStatus;
	private Integer ExamStatus;
	private Integer ReOrderChoiceStatus;
	
	private Integer ALREADYITEM;
	private Integer SubjectID;
	private String SubjectCode;
	private String NOFExamItem;
	private Integer NOFChoice;
	private Integer RightChoice;
	private Integer ObjectiveFormat;
	private Integer ObjetiveAnswer;
	private Integer VerifyExamItemStatus;
	private Integer DisableStatus;
	
	public Integer getExamItemID() {
		return ExamItemID;
	}
	public void setExamItemID(Integer examItemID) {
		ExamItemID = examItemID;
	}
	public Integer getObjectiveFormat() {
		return ObjectiveFormat;
	}
	public void setObjectiveFormat(Integer objectiveFormat) {
		ObjectiveFormat = objectiveFormat;
	}
	public Integer getObjetiveAnswer() {
		return ObjetiveAnswer;
	}
	public void setObjetiveAnswer(Integer objetiveAnswer) {
		ObjetiveAnswer = objetiveAnswer;
	}
	public Integer getRightChoice() {
		return RightChoice;
	}
	public void setRightChoice(Integer rightChoice) {
		RightChoice = rightChoice;
	}
	public Integer getNOFChoice() {
		return NOFChoice;
	}
	public void setNOFChoice(Integer nOFChoice) {
		NOFChoice = nOFChoice;
	}
	public String getNOFExamItem() {
		return NOFExamItem;
	}
	public void setNOFExamItem(String nOFExamItem) {
		NOFExamItem = nOFExamItem;
	}
	public Integer getSubjectID() {
		return SubjectID;
	}
	public void setSubjectID(Integer subjectID) {
		SubjectID = subjectID;
	}
	public String getSubjectCode() {
		return SubjectCode;
	}
	public void setSubjectCode(String subjectCode) {
		SubjectCode = subjectCode;
	}
	public Integer getALREADYITEM() {
		return ALREADYITEM;
	}
	public void setALREADYITEM(Integer aLREADYITEM) {
		ALREADYITEM = aLREADYITEM;
	}
	public Integer getExamFormItemOrder() {
		return ExamFormItemOrder;
	}
	public void setExamFormItemOrder(Integer examFormItemOrder) {
		ExamFormItemOrder = examFormItemOrder;
	}
	public Integer getUnitOrder() {
		return UnitOrder;
	}
	public void setUnitOrder(Integer unitOrder) {
		UnitOrder = unitOrder;
	}
	public Integer getSectionOrder() {
		return SectionOrder;
	}
	public void setSectionOrder(Integer sectionOrder) {
		SectionOrder = sectionOrder;
	}
	public Integer getObjectiveOrder() {
		return ObjectiveOrder;
	}
	public void setObjectiveOrder(Integer objectiveOrder) {
		ObjectiveOrder = objectiveOrder;
	}
	public String getCode() {
		return Code;
	}
	public void setCode(String code) {
		Code = code;
	}
	
	@Column(name = "Name")
	public String getName() {
		return Name;
	}
	public void setName(String name) {
		Name = name;
	}
	public Integer getExamGroupType() {
		return ExamGroupType;
	}
	public void setExamGroupType(Integer examGroupType) {
		ExamGroupType = examGroupType;
		this.ExamGroupTypeName = TYPE_EXAM_GROUP.getEnum(this.ExamGroupType).getMessage();
	}
	public Integer getExamType() {
		return ExamType;
	}
	public void setExamType(Integer examType) {
		ExamType = examType;
		if(this.ExamType != -1){
			this.ExamTypeName = TYPE_EXAM.getEnum(this.ExamType).getMessage();
		}
	}
	
	public Integer getExamFormItemID() {
		return ExamFormItemID;
	}
	public void setExamFormItemID(Integer examFormItemID) {
		ExamFormItemID = examFormItemID;
	}
	public Integer getExamFormItemGroupID() {
		return ExamFormItemGroupID;
	}
	public void setExamFormItemGroupID(Integer examFormItemGroupID) {
		ExamFormItemGroupID = examFormItemGroupID;
	}
	
	public String getExamGroupTypeName() {
		return ExamGroupTypeName;
	}
	public void setExamGroupTypeName(String examGroupTypeName) {
		ExamGroupTypeName = examGroupTypeName;
	}
	public String getExamTypeName() {
		return ExamTypeName;
	}
	public void setExamTypeName(String examTypeName) {
		ExamTypeName = examTypeName;
	}
	
	
	public Integer getGroupOrder() {
		return GroupOrder;
	}
	public void setGroupOrder(Integer groupOrder) {
		GroupOrder = groupOrder;
	}
	public Integer getDataStatus() {
		return DataStatus;
	}
	public void setDataStatus(Integer dataStatus) {
		DataStatus = dataStatus;
	}
	public Integer getExamStatus() {
		return ExamStatus;
	}
	public void setExamStatus(Integer examStatus) {
		ExamStatus = examStatus;
	}
	public Integer getReOrderChoiceStatus() {
		return ReOrderChoiceStatus;
	}
	public void setReOrderChoiceStatus(Integer reOrderChoiceStatus) {
		ReOrderChoiceStatus = reOrderChoiceStatus;
	}
	
	public Integer getVerifyExamItemStatus() {
		return VerifyExamItemStatus;
	}
	public void setVerifyExamItemStatus(Integer verifyExamItemStatus) {
		VerifyExamItemStatus = verifyExamItemStatus;
	}
	public String toString() {
		StringBuffer temp = new StringBuffer();
		temp.append("ExamFormItemGroupID : "+ExamFormItemGroupID+ "]\n");
		temp.append("ExamFormItemID : "+ExamFormItemID+ "]\n");
		temp.append("ExamFormItemOrder : "+ExamFormItemOrder+ "]\n");
		temp.append("UnitOrder : "+UnitOrder+ "]\n");
		temp.append("SectionOrder : "+SectionOrder+ "]\n");
		temp.append("ObjectiveOrder : "+ObjectiveOrder+ "]\n");
		temp.append("Code : "+Code+ "]\n");
		temp.append("Name : "+Name+ "]\n");
		temp.append("ExamGroupType : "+ExamGroupType+ "]\n");
		temp.append("ExamGroupTypeName : "+ExamGroupTypeName+ "]\n");
		temp.append("ExamType : "+ExamType+ "]\n");
		temp.append("ExamTypeName : "+ExamTypeName+ "]\n");
		temp.append("GroupOrder : "+GroupOrder+ "]\n");
		temp.append("DataStatus : "+DataStatus+ "]\n");
		temp.append("ExamStatus : "+ExamStatus+ "]\n");
		temp.append("ReOrderChoiceStatus : "+ReOrderChoiceStatus+ "]\n");
		return temp.toString();
	}
	ResultTransformer aliasTransformer = Transformers.aliasToBean(ExamFormItemResult.class);
	
	@Override
	public List transformList(List list) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformList", "[START] @@@");
		List<ExamFormItemResult> result = aliasTransformer.transformList(list);
		for(int i = 0;i < result.size();i++){
			ExamFormItemResult lo_ExamFormItemResult = result.get(i);
			result.get(i).setExamGroupTypeName(TYPE_EXAM_GROUP.getEnum(result.get(i).getExamGroupType()).getMessage());
			if(lo_ExamFormItemResult.getExamType() != -1){
				result.get(i).setExamTypeName(TYPE_EXAM.getEnum(result.get(i).getExamType()).getMessage());
			}
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformList", "[END] @@@");
        return result;
	}
	@Override
	public Object transformTuple(Object[] os, String[] strings) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformTuple", "[START] @@@");
		Object result = aliasTransformer.transformTuple(os, strings);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormItemGenerator", "transformTuple", "[END] @@@");
         return result;
	}
	public Integer getDisableStatus() {
		return DisableStatus;
	}
	public void setDisableStatus(Integer disableStatus) {
		DisableStatus = disableStatus;
	}
	
	
}
