package esi.examwh.bl.examscheduledetail;

import java.util.List;

import esi.examwh.bl.subjectformpolicy.GroupConditionResult;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;

import org.hibernate.transform.ResultTransformer;
import org.hibernate.transform.Transformers;

public class Report13Result implements java.io.Serializable, ResultTransformer{

	private Integer SubjectID;
	private String SubjectCode;
	private String SubjectName;
	private Integer NumberOfExamForm;
	
	
	
	public Integer getSubjectID() {
		return SubjectID;
	}
	public void setSubjectID(Integer subjectID) {
		SubjectID = subjectID;
	}
	public String getSubjectCode() {
		return SubjectCode;
	}
	public void setSubjectCode(String subjectCode) {
		SubjectCode = subjectCode;
	}
	public String getSubjectName() {
		return SubjectName;
	}
	public void setSubjectName(String subjectName) {
		SubjectName = subjectName;
	}
	public Integer getNumberOfExamForm() {
		return NumberOfExamForm;
	}
	public void setNumberOfExamForm(Integer numberOfExamForm) {
		NumberOfExamForm = numberOfExamForm;
	}
	ResultTransformer aliasTransformer = Transformers.aliasToBean(Report13Result.class);
	
	@Override
	public List transformList(List list) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "transformList", "[START] @@@");
		List<Report13Result> result = aliasTransformer.transformList(list);
		for(int i = 0;i < result.size();i++){
			Report13Result lo_Report13Result = result.get(i);
		}
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "transformList", "[END] @@@");
        return result;
	}
	@Override
	public Object transformTuple(Object[] os, String[] strings) {
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "transformTuple", "[START] @@@");
		Object result = aliasTransformer.transformTuple(os, strings);
		CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "Report13Generator", "transformTuple", "[END] @@@");
         return result;
	}

}
