package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_APPLICANT  implements PersistentEnum{
	TYPE_INSIDER(10, "บุคคลภายใน"), 
	TYPE_OUTSIDER(20, "บุคคลภายนอก");

	private static final int[] StatusValue = { 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_APPLICANT(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_APPLICANT getEnum(int Data) {
		TYPE_APPLICANT[] CheckList = TYPE_APPLICANT.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_APPLICANT.TYPE_INSIDER;
	}

	public TYPE_APPLICANT[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_APPLICANT[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_APPLICANT[] ResultList = new TYPE_APPLICANT[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_APPLICANT.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_APPLICANT[0];
		} else {
			TYPE_APPLICANT[] ResultList = new TYPE_APPLICANT[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_APPLICANT.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}
