package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_CHOICE_SORT_ORDER  implements PersistentEnum{
	TYPE_SORT_VERTICAL(10, "แบบแนวตั้ง"), 
	TYPE_SORT_N_STYLE(20, "แบบ N Style"),
	TYPE_SORT_HORIZONTAL(30, "แบบแนวนอน");

	private static final int[] StatusValue = { 10, 20,30 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_CHOICE_SORT_ORDER(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_CHOICE_SORT_ORDER getEnum(int Data) {
		TYPE_CHOICE_SORT_ORDER[] CheckList = TYPE_CHOICE_SORT_ORDER.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_CHOICE_SORT_ORDER.TYPE_SORT_VERTICAL;
	}

	public TYPE_CHOICE_SORT_ORDER[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_CHOICE_SORT_ORDER[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_CHOICE_SORT_ORDER[] ResultList = new TYPE_CHOICE_SORT_ORDER[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_CHOICE_SORT_ORDER.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_CHOICE_SORT_ORDER[0];
		} else {
			TYPE_CHOICE_SORT_ORDER[] ResultList = new TYPE_CHOICE_SORT_ORDER[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_CHOICE_SORT_ORDER.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}