package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_COMPANY  implements PersistentEnum{
	TYPE_STOU(10, "มสธ."), 
	TYPE_BAAC(20, "ธกส.");

	private static final int[] StatusValue = { 1, 2, 3, 4, 5 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_COMPANY(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_COMPANY getEnum(int Data) {
		TYPE_COMPANY[] CheckList = TYPE_COMPANY.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_COMPANY.TYPE_STOU;
	}

	public TYPE_COMPANY[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_COMPANY[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_COMPANY[] ResultList = new TYPE_COMPANY[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_COMPANY.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_COMPANY[0];
		} else {
			TYPE_COMPANY[] ResultList = new TYPE_COMPANY[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_COMPANY.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}
