package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_CONDITION_P_VALUE  implements PersistentEnum{
	TYPE_LESS_THAN(10, "น้อยกว่า"), 
	TYPE_EQUAL(20, "เท่ากับ"),
	TYPE_BOTH(30, "น้อยกว่าและเท่ากับ");

	private static final int[] StatusValue = { 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_CONDITION_P_VALUE(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_CONDITION_P_VALUE getEnum(int Data) {
		TYPE_CONDITION_P_VALUE[] CheckList = TYPE_CONDITION_P_VALUE.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_CONDITION_P_VALUE.TYPE_LESS_THAN;
	}

	public TYPE_CONDITION_P_VALUE[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_CONDITION_P_VALUE[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_CONDITION_P_VALUE[] ResultList = new TYPE_CONDITION_P_VALUE[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_CONDITION_P_VALUE.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_CONDITION_P_VALUE[0];
		} else {
			TYPE_CONDITION_P_VALUE[] ResultList = new TYPE_CONDITION_P_VALUE[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_CONDITION_P_VALUE.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}