package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_CONFIG_VERIFY_STATUS implements PersistentEnum {
	STATUS_NONE(10,"ไม่ถูกใช้งาน"),
	STATUS_VERIFY(90,"ถูกใช้งาน");
	

	private static final int[] StatusValue = {10, 90};

	private static final int[][] StatusFlow = { {10, 10, 90}, {90, 90, 10} };

	private int Value;
	private String Message;

	private TYPE_CONFIG_VERIFY_STATUS(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_CONFIG_VERIFY_STATUS getEnum(int Data) {
		TYPE_CONFIG_VERIFY_STATUS[] CheckList = TYPE_CONFIG_VERIFY_STATUS.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return null;
	}
	public static TYPE_CONFIG_VERIFY_STATUS [] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_CONFIG_VERIFY_STATUS [] ResultList = new TYPE_CONFIG_VERIFY_STATUS [StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_CONFIG_VERIFY_STATUS .getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_CONFIG_VERIFY_STATUS [0];
		} else {
			TYPE_CONFIG_VERIFY_STATUS [] ResultList = new TYPE_CONFIG_VERIFY_STATUS [StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_CONFIG_VERIFY_STATUS.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}