package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAM  implements PersistentEnum{
	TYPE_OBJECTIVE(10, "ปรนัย"),
	TYPE_SUBJECTIVE(20, "อัตนัย");

	private static final int[] StatusValue = { 10, 20 ,30 ,40, 50, 60, 70 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAM(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAM getEnum(int Data) {
		TYPE_EXAM[] CheckList = TYPE_EXAM.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAM.TYPE_OBJECTIVE;
	}

	public TYPE_EXAM[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAM[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAM[] ResultList = new TYPE_EXAM[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAM.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAM[0];
		} else {
			TYPE_EXAM[] ResultList = new TYPE_EXAM[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAM.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}