package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAMFORM_STATUS implements PersistentEnum {
	STATUS_EXAMFORM_NEW(100, "สร้างใหม่"), 
	STATUS_EXAMFORM_DRAF1(200, "ร่าง 1"),
	STATUS_EXAMFORM_DRAF2(300, "ร่าง 2"),
	STATUS_EXAMFORM_DRAF3(400, "ร่าง 3"),
	STATUS_EXAMFORM_DRAF4(500, "ร่าง 4"),
	STATUS_EXAMFORM_COMPLETE_READY_TO_PRINTERY(600, "สมบูรณ์พร้อมส่งโรงพิมพ์"),
	STATUS_EXAMFORM_SENT_PRINTERY(700,"ส่งโรงพิมพ์แล้ว"),
	STATUS_EXAMFORM_END(800,"สิ้นสุดกระบวนการ");
	
	
	private static final int[] StatusValue = { 100, 200, 300, 400, 500, 600, 700, 800 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAMFORM_STATUS(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAMFORM_STATUS getEnum(int Data) {
		TYPE_EXAMFORM_STATUS[] CheckList = TYPE_EXAMFORM_STATUS.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAMFORM_STATUS.STATUS_EXAMFORM_NEW;
	}

	public TYPE_EXAMFORM_STATUS[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAMFORM_STATUS[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAMFORM_STATUS[] ResultList = new TYPE_EXAMFORM_STATUS[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAMFORM_STATUS.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAMFORM_STATUS[0];
		} else {
			TYPE_EXAMFORM_STATUS[] ResultList = new TYPE_EXAMFORM_STATUS[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAMFORM_STATUS.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}