package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAMINATION_STATUS implements PersistentEnum {
	STATUS_EXAMINATION_NEW(10, "สร้างใหม่"), 
	STATUS_EXAMINATION_EXAM_ITEM(11, "บันทึกข้อสอบ"), 
	STATUS_EXAMINATION_SELECT_ITEM(12, "คัดเลือกข้อสอบ"), 
	STATUS_EXAMINATION_CREATE_EXAM(20, "จัดทำแบบทดสอบ"),
	STATUS_EXAMINATION_DISABLE(30, "ระงับการจัดทำแบบทดสอบ"),
	STATUS_EXAMINATION_END(40, "สิ้นสุดการจัดสอบ"),
	STATUS_EXAMINATION_CANCLE(50, "ยกเลิกการจัดสอบ"),
	STATUS_EXAMINATION_TEMPORARY(99, "จัดเก็บข้อสอบเก่า");
	
	private static final int[] StatusValue = { 10,11,12, 20, 30 , 40, 50,99 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAMINATION_STATUS(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAMINATION_STATUS getEnum(int Data) {
		TYPE_EXAMINATION_STATUS[] CheckList = TYPE_EXAMINATION_STATUS.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAMINATION_STATUS.STATUS_EXAMINATION_NEW;
	}

	public TYPE_EXAMINATION_STATUS[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAMINATION_STATUS[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAMINATION_STATUS[] ResultList = new TYPE_EXAMINATION_STATUS[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAMINATION_STATUS.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAMINATION_STATUS[0];
		} else {
			TYPE_EXAMINATION_STATUS[] ResultList = new TYPE_EXAMINATION_STATUS[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAMINATION_STATUS.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}