package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAM_FROM_SYSTEM  implements PersistentEnum{
	TYPE_EXAM_WAREHOUSE_NEW(10, "ข้อสอบจากระบบคลังใหม่"), 
	TYPE_EXAM_WAREHOUSE_OLD(20, "ข้อสอบจากระบบคลังเก่า"),
	TYPE_WALK_IN_EXAM(30, "ข้อสอบจากระบบ WALK-IN EXAM");

	private static final int[] StatusValue = { 10, 20,30 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAM_FROM_SYSTEM(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAM_FROM_SYSTEM getEnum(int Data) {
		TYPE_EXAM_FROM_SYSTEM[] CheckList = TYPE_EXAM_FROM_SYSTEM.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAM_FROM_SYSTEM.TYPE_EXAM_WAREHOUSE_NEW;
	}

	public TYPE_EXAM_FROM_SYSTEM[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAM_FROM_SYSTEM[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAM_FROM_SYSTEM[] ResultList = new TYPE_EXAM_FROM_SYSTEM[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAM_FROM_SYSTEM.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAM_FROM_SYSTEM[0];
		} else {
			TYPE_EXAM_FROM_SYSTEM[] ResultList = new TYPE_EXAM_FROM_SYSTEM[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAM_FROM_SYSTEM.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}
