package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAM_GROUP  implements PersistentEnum{
	TYPE_SINGLE_QUESTION(10, "โจทย์เดี่ยว"), 
	TYPE_SUB_QUESTION(20, "โจทย์ย่อย"),
	TYPE_GROUP_QUESTION(30, "โจทย์ร่วม");

	private static final int[] StatusValue = { 10, 20, 30 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAM_GROUP(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAM_GROUP getEnum(int Data) {
		TYPE_EXAM_GROUP[] CheckList = TYPE_EXAM_GROUP.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAM_GROUP.TYPE_SINGLE_QUESTION;
	}

	public TYPE_EXAM_GROUP[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAM_GROUP[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAM_GROUP[] ResultList = new TYPE_EXAM_GROUP[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAM_GROUP.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAM_GROUP[0];
		} else {
			TYPE_EXAM_GROUP[] ResultList = new TYPE_EXAM_GROUP[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAM_GROUP.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}