package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_EXAM_STATUS implements PersistentEnum {
	STATUS_EXAM_NEW(0, "ใหม่"), 
	STATUS_EXAM_DRAF1(10, "ร่าง 1"),
	STATUS_EXAM_DRAF2(20, "ร่าง 2"),
	STATUS_EXAM_DRAF3(30, "ร่าง 3"),
	STATUS_EXAM_DRAF4(40, "ร่าง 4"),
	STATUS_EXAM_READY(50, "พร้อมใช้งาน"),
	STATUS_EXAM_DISABLE(90, "ระงับการใช้งาน");
	private static final int[] StatusValue = { 0, 10, 20, 30, 40, 50, 90 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_EXAM_STATUS(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_EXAM_STATUS getEnum(int Data) {
		TYPE_EXAM_STATUS[] CheckList = TYPE_EXAM_STATUS.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_EXAM_STATUS.STATUS_EXAM_NEW;
	}

	public TYPE_EXAM_STATUS[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_EXAM_STATUS[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_EXAM_STATUS[] ResultList = new TYPE_EXAM_STATUS[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_EXAM_STATUS.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_EXAM_STATUS[0];
		} else {
			TYPE_EXAM_STATUS[] ResultList = new TYPE_EXAM_STATUS[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_EXAM_STATUS.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}