
package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_FLAG implements PersistentEnum{
	TYPE_NO(10, "ไม่ใช่"),
	TYPE_YES(20, "ใช่"); 
	private static final int[] StatusValue = { 10, 20};

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_FLAG(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_FLAG getEnum(int Data) {
		TYPE_FLAG[] CheckList = TYPE_FLAG.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_FLAG.TYPE_NO;
	}

	public TYPE_FLAG[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_FLAG[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus.equals(StatusFlow[i][0])) {
					TYPE_FLAG[] ResultList = new TYPE_FLAG[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_FLAG.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_FLAG[0];
		} else {
			TYPE_FLAG[] ResultList = new TYPE_FLAG[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_FLAG.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

}