package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_OBJECTIVE_FORMAT  implements PersistentEnum{
	TYPE_OBJECTIVE_WITH_CHOICE(10, "ข้อสอบปรนัยแยกตัวเลือก"), 
	TYPE_OBJECTIVE_NO_CHOICE(20, "ข้อสอบปรนัยรวมตัวเลือก"),
	TYPE_SUBJECTIVE(30, "ข้อสอบอัตนัย");
	
	private static final int[] StatusValue = { 10, 20, 30 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;
	
	private TYPE_OBJECTIVE_FORMAT(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return Value;
	}

	public void setValue(int value) {
		Value = value;
	}

	public String getMessage() {
		return Message;
	}

	public void setMessage(String message) {
		Message = message;
	}

	public static int[] getStatusvalue() {
		return StatusValue;
	}
	public static TYPE_OBJECTIVE_FORMAT getEnum(int Data) {
		TYPE_OBJECTIVE_FORMAT[] CheckList = TYPE_OBJECTIVE_FORMAT.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_OBJECTIVE_FORMAT.TYPE_OBJECTIVE_WITH_CHOICE;
	}

	public TYPE_OBJECTIVE_FORMAT[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_OBJECTIVE_FORMAT[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_OBJECTIVE_FORMAT[] ResultList = new TYPE_OBJECTIVE_FORMAT[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_OBJECTIVE_FORMAT.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_OBJECTIVE_FORMAT[0];
		} else {
			TYPE_OBJECTIVE_FORMAT[] ResultList = new TYPE_OBJECTIVE_FORMAT[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_OBJECTIVE_FORMAT.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

}
