package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_OPERATION_STATUS implements PersistentEnum {
	STATUS_OPERATION_ACTION(10, "จัดทำแบบทดสอบ"), 
	STATUS_OPERATION_END(20, "สิ้นสุดการทำงาน");

	private static final int[] StatusValue = { 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_OPERATION_STATUS(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_OPERATION_STATUS getEnum(int Data) {
		TYPE_OPERATION_STATUS[] CheckList = TYPE_OPERATION_STATUS.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_OPERATION_STATUS.STATUS_OPERATION_ACTION;
	}

	public TYPE_OPERATION_STATUS[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_OPERATION_STATUS[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_OPERATION_STATUS[] ResultList = new TYPE_OPERATION_STATUS[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_OPERATION_STATUS.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_OPERATION_STATUS[0];
		} else {
			TYPE_OPERATION_STATUS[] ResultList = new TYPE_OPERATION_STATUS[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_OPERATION_STATUS.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}