package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_REMUNERATION_CALCULATE  implements PersistentEnum{
	TYPE_OBJECTIVE(10, "ปรนัย"), 
	TYPE_SUBJECTIVE(20, "อัตนัย"),
	TYPE_OBJECTIVE_SUBJECTIVE(30, "ปรนัยและอัตนัย");

	private static final int[] StatusValue = { 10, 20, 30 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_REMUNERATION_CALCULATE(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_REMUNERATION_CALCULATE getEnum(int Data) {
		TYPE_REMUNERATION_CALCULATE[] CheckList = TYPE_REMUNERATION_CALCULATE.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_REMUNERATION_CALCULATE.TYPE_OBJECTIVE;
	}

	public TYPE_REMUNERATION_CALCULATE[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_REMUNERATION_CALCULATE[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_REMUNERATION_CALCULATE[] ResultList = new TYPE_REMUNERATION_CALCULATE[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_REMUNERATION_CALCULATE.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_REMUNERATION_CALCULATE[0];
		} else {
			TYPE_REMUNERATION_CALCULATE[] ResultList = new TYPE_REMUNERATION_CALCULATE[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_REMUNERATION_CALCULATE.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}
