package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_RandomOrderChoiceStatus  implements PersistentEnum{
	STATUS_DONOT_ALLOW_Random(10, "ไม่อนุญาตให้สุ่มลำดับตัวเลือก"), 
	STATUS_ALLOW_Random(20, "อนุญาตให้สุ่มลำดับตัวเลือก");

	private static final int[] StatusValue = { 10, 20 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_RandomOrderChoiceStatus(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_RandomOrderChoiceStatus getEnum(int Data) {
		TYPE_RandomOrderChoiceStatus[] CheckList = TYPE_RandomOrderChoiceStatus.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_RandomOrderChoiceStatus.STATUS_DONOT_ALLOW_Random;
	}

	public TYPE_RandomOrderChoiceStatus[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_RandomOrderChoiceStatus[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_RandomOrderChoiceStatus[] ResultList = new TYPE_RandomOrderChoiceStatus[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_RandomOrderChoiceStatus.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_RandomOrderChoiceStatus[0];
		} else {
			TYPE_RandomOrderChoiceStatus[] ResultList = new TYPE_RandomOrderChoiceStatus[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_RandomOrderChoiceStatus.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}

//	 }
}