package esi.examwh.model.common;

import esi.examwh.model.common.persistent.PersistentEnum;

public enum TYPE_SUBJECTIVE_NOTIFY  implements PersistentEnum{
	TYPE_NO_NOTIFY(10, "ไม่แสดงข้อความข้อสอบอัตนัย"), 
	TYPE_NOTIFY_ALL_EXAM(20, "แสดงข้อความให้ผู้เข้าสอบทำข้อสอบทุกข้อ"),
	TYPE_NOTIFY_ASSIGN_EXAM(30, "แสดงข้อความให้ผู้เข้าสอบทำข้อที่กำหนด"),
	TYPE_NOTIFY_DECIDE_EXAM(40, "แสดงข้อความให้ผู้เข้าสอบเลือกทำข้อสอบที่กำหนด"),
	TYPE_OTHER(900,"อื่นๆ");

	private static final int[] StatusValue = { 10, 20, 30, 40, 900 };

	private static final int[][] StatusFlow = { };

	private int Value;
	private String Message;

	private TYPE_SUBJECTIVE_NOTIFY(int value, String message) {
		this.Value = value;
		this.Message = message;
	}

	public int getValue() {
		return this.Value;
	}

	public static int[] getStatusValue() {
		return StatusValue;
	}

	public static int[][] getStatusFlow() {
		return StatusFlow;
	}

	public void setValue(int value) {
		this.Value = value;
	}

	public String getMessage() {
		return this.Message;
	}

	public void setMessage(String message) {
		this.Message = message;
	}

	public static TYPE_SUBJECTIVE_NOTIFY getEnum(int Data) {
		TYPE_SUBJECTIVE_NOTIFY[] CheckList = TYPE_SUBJECTIVE_NOTIFY.values();
		for (int i = 0; i < CheckList.length; i++) {
			if (CheckList[i].getValue() == Data) {
				return CheckList[i];
			}
		}
		return TYPE_SUBJECTIVE_NOTIFY.TYPE_NO_NOTIFY;
	}

	public TYPE_SUBJECTIVE_NOTIFY[] getValues(int ai_Mode) {
		return null;
	}

	public static TYPE_SUBJECTIVE_NOTIFY[] GetNextState(Integer ai_CurrStatus) {
		if (ai_CurrStatus != null) {
			for (int i = 0; i < StatusFlow.length; i++) {
				if (ai_CurrStatus == StatusFlow[i][0]) {
					TYPE_SUBJECTIVE_NOTIFY[] ResultList = new TYPE_SUBJECTIVE_NOTIFY[StatusFlow[i].length-1];
					for (int j = 1; j < StatusFlow[i].length; j++) {
						ResultList[j-1] = TYPE_SUBJECTIVE_NOTIFY.getEnum(StatusFlow[i][j]);
					}
					return ResultList;
				}
			}
			return new TYPE_SUBJECTIVE_NOTIFY[0];
		} else {
			TYPE_SUBJECTIVE_NOTIFY[] ResultList = new TYPE_SUBJECTIVE_NOTIFY[StatusFlow[0].length-1];
			for (int j = 1; j < StatusFlow[0].length; j++) {
				ResultList[j-1] = TYPE_SUBJECTIVE_NOTIFY.getEnum(StatusFlow[0][j]);
			}
			return ResultList;
		}
	}
}
