package esi.examwh.testBL;

import esi.examwh.bl.SubjectCollatorBL;
import esi.examwh.dao.PersonDAO;
import esi.examwh.dao.SubjectDAO;
import esi.examwh.dao.common.CommonLog;
import esi.examwh.dao.common.LOG_LEVEL;
import esi.examwh.dao.util.ExamWHDaoUtil;
import esi.examwh.model.Person;
import esi.examwh.model.Subject;
import esi.examwh.model.SubjectCollator;
import esi.examwh.model.SubjectCollatorPK;
import esi.examwh.model.common.TYPE_DATA_STATUS;

import org.hibernate.Session;
import org.hibernate.Transaction;

import com.plw.util.DataNotFoundException;
import com.plw.util.OutOfListException;

public class SubjectCollatorTestBL {
	public static void UTTestAdd() throws OutOfListException, DataNotFoundException {
		Integer ai_SubjectID = 1;
		Integer ai_PersonID = 2;
		
		Session MyHSs = ExamWHDaoUtil.getSession();
		Transaction MyHTs = MyHSs.beginTransaction();
		SubjectCollator newSubjectCollator = new SubjectCollator();
		try {
			if(ai_PersonID != null){
				Person lo_Person = PersonDAO.GetByID(MyHSs,ai_PersonID, null,null);
				
				newSubjectCollator.setOPersonID(lo_Person);
			}
			if(ai_SubjectID != null){
				Subject lo_Subject = SubjectDAO.GetByID(MyHSs,ai_SubjectID, null,null);
				newSubjectCollator.setOSubjectID(lo_Subject);
			}
			newSubjectCollator.setDataStatus(TYPE_DATA_STATUS.STATUS_NEW);
			SubjectCollatorPK lo_PK = new SubjectCollatorPK();
			lo_PK.setPersonID(ai_PersonID);
			lo_PK.setSubjectID(ai_SubjectID);
			newSubjectCollator.setPK(lo_PK);
			SubjectCollatorBL.Add(MyHSs,newSubjectCollator,"ExamWH Engine", null, null);
			MyHTs.commit();
		} catch (Exception e) {
			CommonLog.Print(LOG_LEVEL.INFO_LEVEL, "ExamFormTestDAO", "UTTestAdd", "@Can't insert@");
			e.printStackTrace();
			MyHTs.rollback();
		}
		MyHSs.close();
		
	}
	
	public static void main(String[] args) {
		try {
			SubjectCollatorTestBL.UTTestAdd();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
